/*
Java Hummer Project
File: Config.java
Date: 1-16-98
Author: Joel Marlow & Chad Ward
Description:  Object containing some information and a meaning behind
              the information.  Can be used for sending just
              information or sending a predefined response type
              with a message.

 Copyright (C) 1997-1998 The Hummer Project - hummer@csds.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
package edu.uidaho.hummer.dataobject;

import java.io.Serializable;
import java.util.Date;
import java.util.*;

/**
This is the basic Config Object.  When a message is sent on the wire, it is
a serialization of this object with an additional type.  All communication between Servers and Clients
that deal with passing configuration information, are passing these.  Also notice that _type is a power
 of 2, so that masking can be done on the type.

@author Joel Marlow & Chad Ward
*/
public class Config implements Serializable{

  /**
  This holds the sql statements that need to be done.

  @serial
   */
  public Vector data = new Vector();
};
