/*
Java Hummer Project
File: hdu.java
Date: 
Author: Tiffany Cavanaugh
Description: 
             This file contains the gui for the cs480 project hdu.

 Copyright (C) 1997-1998 The Hummer Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
import java.lang.*;
import java.util.*;
import java.sql.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import com.netbeans.developer.awt.*;
/**

<h4>Class Usage and Flow:</h4>
<ul>
<li>This class is the interface for the tool HDU.
<li>Hummer Database Utility
<li>This class is a gui with three main tabs.
<li>1. The Database Utility
<li>2. Modify Property
<li>3. Insert Property
<li>This class makes database calls, manipulates initialization
<li>file, and manipulates the property file.
</ul>
@author Tiffany Cavanaugh
*/

public class copy_test extends javax.swing.JFrame {
  
  /** Initializes the Form */
  public copy_test() {
      /*
	constructor:
	calls the following methods when the program is 
	first run.
      */
      
      host();  
      readPropertyFile();
      element();
      initComponents ();
      host_name();
      try{
	  sqlStatements();
      }
      catch(SQLException e){
	  System.exit(0);
      }
      addComboItems();
      try{
	  initializationFile();
      }
      catch(Exception e){
      System.err.println("Constructor: " +e);
      /*
	if an error is thrown when trying to find
	the file add_values.sql then we will make
	sure we don't try to load the file.
      */
      found_file = false;
      }
      pack ();
  }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    
    /*
      The code created by the program Net Beans.  This code sets up the 
      Graphical interface.  It is the actual methods that we are
      more interested in.
    */

    private void initComponents () {
	addWindowListener (new java.awt.event.WindowAdapter () {
	    public void windowClosing (java.awt.event.WindowEvent evt) {
		exitForm (evt);
	    }
	}
			   );
	
	getContentPane ().setLayout 
	    (new com.netbeans.developer.awt.AbsoluteLayout ());
	
	database_tab = new javax.swing.JTabbedPane ();
	
	database = new javax.swing.JPanel ();
	database.setBorder (new javax.swing.border.BevelBorder 
			    (0, java.awt.Color.white, java.awt.Color.white,
			     new java.awt.Color (134, 134, 134),
			     new java.awt.Color (93, 93, 93)));
	
	database.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
	
    d_hostname_panel = new javax.swing.JPanel ();
    d_hostname_panel.setBorder (new javax.swing.border.BevelBorder 
				(0, java.awt.Color.white, java.awt.Color.white, 
				 new java.awt.Color (134, 134, 134),
				 new java.awt.Color (93, 93, 93)));
    
    
    d_hostname_panel.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
    

    d_hostname_text = new javax.swing.JTextField ();
    d_hostname_text.setEditable(false);
    d_hostname_text.setBorder (new javax.swing.border.TitledBorder 
			       (new javax.swing.border.BevelBorder (0), "Host", 1, 2,
				new java.awt.Font ("Dialog", 1, 10)));
    d_hostname_panel.add (d_hostname_text, 
			  new com.netbeans.developer.awt.AbsoluteConstraints 
			  (20, 10, 270, 40));
    
    d_databasename_text = new javax.swing.JTextField ();
    d_databasename_text.setEditable(false);
    d_databasename_text.setBorder (new javax.swing.border.TitledBorder 
				   (new javax.swing.border.BevelBorder (0), 
				    "Database Name", 1, 2,
				    new java.awt.Font ("Dialog", 1, 10)));
    d_hostname_panel.add (d_databasename_text, 
			  new com.netbeans.developer.awt.AbsoluteConstraints 
			  (350, 10, 260, 40));
    
    database.add (d_hostname_panel, 
		  new com.netbeans.developer.awt.AbsoluteConstraints
		  (10, 330, 640, 60));

    d_database_panel = new javax.swing.JPanel ();
    d_database_panel.setBorder (new javax.swing.border.TitledBorder 
				(new javax.swing.border.BevelBorder (0),
				 "Database Manipulation Options", 1, 2,
				 new java.awt.Font ("Dialog", 1, 10)));
    d_database_panel.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
    
    d_removetables_button = new javax.swing.JButton ();
    d_removetables_button.setBorder (new javax.swing.border.BevelBorder (0));
    d_removetables_button.setText ("Remove All Tables");
    d_removetables_button.setActionCommand ("Remove_tables");
    d_removetables_button.setFont (new java.awt.Font ("Dialog", 0, 10));
    d_removetables_button.addMouseListener (new java.awt.event.MouseAdapter () {
     

      public void mouseClicked (java.awt.event.MouseEvent evt) {
	d_removetables_buttonMouseClicked (evt);
      }
    }
					    );
    d_database_panel.add (d_removetables_button, 
			  new com.netbeans.developer.awt.AbsoluteConstraints 
			  (50, 20, 150, 20));

    d_createtables_button = new javax.swing.JButton ();
    d_createtables_button.setBorder (new javax.swing.border.BevelBorder (0));
    d_createtables_button.setText ("Create all Tables");
    d_createtables_button.setActionCommand ("Create tables");
    d_createtables_button.setFont (new java.awt.Font ("Dialog", 0, 10));
    d_createtables_button.addMouseListener (new java.awt.event.MouseAdapter () {
      public void mouseClicked (java.awt.event.MouseEvent evt) {
	d_createtables_buttonMouseClicked (evt);
      }
    }
					    );
    d_database_panel.add (d_createtables_button, 
			  new com.netbeans.developer.awt.AbsoluteConstraints 
			  (50, 50, 150, 20));

    d_connection_textField = new javax.swing.JTextField ();
    d_connection_textField.setEditable(false);
    d_connection_textField.setBorder (new javax.swing.border.TitledBorder 
				      (new javax.swing.border.BevelBorder (0),
				       "Connection Display", 1, 2,
				       new java.awt.Font ("Dialog", 1, 10)));
    d_connection_textField.setFont (new java.awt.Font ("Dialog", 0, 10));
    d_database_panel.add (d_connection_textField, 
			  new com.netbeans.developer.awt.AbsoluteConstraints
			  (10, 120, 230, 50));
    
    d_initializeTables_jButton = new javax.swing.JButton ();
    d_initializeTables_jButton.setBorder (new javax.swing.border.BevelBorder (0));
    d_initializeTables_jButton.setText ("Initialize Tables");
    d_initializeTables_jButton.setFont (new java.awt.Font ("Dialog", 0, 10));
    d_initializeTables_jButton.addMouseListener (new java.awt.event.MouseAdapter () {
     

      public void mouseClicked (java.awt.event.MouseEvent evt) {
	d_initializeTables_jButtonMouseClicked (evt);
      }
    }
						 );
    d_database_panel.add (d_initializeTables_jButton,
			  new com.netbeans.developer.awt.AbsoluteConstraints
			  (50, 80, 150, 20));

    database.add (d_database_panel,
		  new com.netbeans.developer.awt.AbsoluteConstraints
		  (10, 10, 260, 220));

    jScrollPane2 = new javax.swing.JScrollPane ();
    
    d_initializationFile_jList = new javax.swing.JList ();
    d_initializationFile_jList.setFont (new java.awt.Font ("Dialog", 0, 10));
     d_initializationFile_jList.addMouseListener (new java.awt.event.MouseAdapter () {
      

      public void mouseClicked (java.awt.event.MouseEvent evt) {
	d_initializationFile_jListMouseClicked (evt);
      }
    }
					   );
    jScrollPane2.add (d_initializationFile_jList);
    
    jScrollPane2.setViewportView (d_initializationFile_jList);
    database.add (jScrollPane2, 
		  new com.netbeans.developer.awt.AbsoluteConstraints
		  (290, 40, 340, 180));
    
    jPanel9 = new javax.swing.JPanel ();
    jPanel9.setBorder (new javax.swing.border.TitledBorder 
		       (new javax.swing.border.BevelBorder (0),
			"Initialization File", 1, 2,
			new java.awt.Font ("Dialog", 1, 10)));
    jPanel9.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
    
    database.add (jPanel9, 
		  new com.netbeans.developer.awt.AbsoluteConstraints
		  (280, 10, 370, 220));
    
    jPanel10 = new javax.swing.JPanel ();
    jPanel10.setBorder (new javax.swing.border.TitledBorder 
			(new javax.swing.border.BevelBorder (0), 
			 "Insert New Initialization Query", 1, 2,
			 new java.awt.Font ("Dialog", 1, 10)));
    jPanel10.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
    jScrollPaneNewQ = new javax.swing.JScrollPane ();
    d_newQuery_textField = new javax.swing.JTextArea ();
    d_newQuery_textField.setFont (new java.awt.Font ("Dialog", 0, 12));
   
    jScrollPaneNewQ.add (d_newQuery_textField);
    
    jScrollPaneNewQ.setViewportView (d_newQuery_textField);
    jPanel10.add (jScrollPaneNewQ, 
				new com.netbeans.developer.awt.AbsoluteConstraints
				(10, 20, 300, 40));
   
    
    d_testQuery_jButton = new javax.swing.JButton ();
    d_testQuery_jButton.setBorder (new javax.swing.border.BevelBorder (0));
    d_testQuery_jButton.setText ("Test Query");
    d_testQuery_jButton.setFont (new java.awt.Font ("Dialog", 0, 10));
    d_testQuery_jButton.addMouseListener (new java.awt.event.MouseAdapter () {
      public void mouseClicked (java.awt.event.MouseEvent evt) {
	d_testQuery_jButtonMouseClicked (evt);
      }
    }
					  );
    jPanel10.add (d_testQuery_jButton, 
		  new com.netbeans.developer.awt.AbsoluteConstraints
		  (350, 20, 80, 30));
    
    d_commit_jButton = new javax.swing.JButton ();
    d_commit_jButton.setBorder (new javax.swing.border.BevelBorder (0));
    d_commit_jButton.setText ("Commit to File");
    d_commit_jButton.setFont (new java.awt.Font ("Dialog", 0, 10));
    d_commit_jButton.addMouseListener (new java.awt.event.MouseAdapter () {
      
      public void mouseClicked (java.awt.event.MouseEvent evt) {
	d_commit_jButtonMouseClicked (evt);
      }
    }
				       );
    jPanel10.add (d_commit_jButton,
		  new com.netbeans.developer.awt.AbsoluteConstraints
		  (440, 20, 80, 30));

    d_clear_jButton = new javax.swing.JButton ();
    d_clear_jButton.setBorder (new javax.swing.border.BevelBorder (0));
    d_clear_jButton.setText ("Clear Form");
    d_clear_jButton.setFont (new java.awt.Font ("Dialog", 0, 10));
    d_clear_jButton.addMouseListener (new java.awt.event.MouseAdapter () {
      public void mouseClicked (java.awt.event.MouseEvent evt) {
	d_clear_jButtonMouseClicked (evt);
      }
    }
				      );
    jPanel10.add (d_clear_jButton,
		  new com.netbeans.developer.awt.AbsoluteConstraints
		  (530, 20, 80, 30));

    database.add (jPanel10, 
		  new com.netbeans.developer.awt.AbsoluteConstraints
		  (10, 230, 640, 90));

    database_tab.addTab ("Database Utility", database);
    
    p_propertyModification_tab = new javax.swing.JPanel ();
    p_propertyModification_tab.setBorder 
      (new javax.swing.border.BevelBorder (0));
    p_propertyModification_tab.setLayout
      (new com.netbeans.developer.awt.AbsoluteLayout ());
    
    m_propertyList_scrollpane = new javax.swing.JScrollPane ();
    
    p_propertyModification_tab.add 
      (m_propertyList_scrollpane, 
       new com.netbeans.developer.awt.AbsoluteConstraints
       (80, 30, -1, -1));

    m_propertyList_scroller = new javax.swing.JScrollPane ();
    m_propertyList_scroller.addMouseListener 
      (new java.awt.event.MouseAdapter () {
	

	public void mouseClicked (java.awt.event.MouseEvent evt) {
	  m_propertyList_jlistMouseClicked (evt);
	}
      }
       );
    
    m_propertyList_jlist = new javax.swing.JList ();
    m_propertyList_jlist.setBorder (new javax.swing.border.BevelBorder (0));
    m_propertyList_jlist.addMouseListener (new java.awt.event.MouseAdapter () {
      

      public void mouseClicked (java.awt.event.MouseEvent evt) {
	m_propertyList_jlistMouseClicked (evt);
      }
    }
					   );
    m_propertyList_scroller.add (m_propertyList_jlist);
    
    m_propertyList_scroller.setViewportView (m_propertyList_jlist);
    p_propertyModification_tab.add 
      (m_propertyList_scroller, 
       new com.netbeans.developer.awt.AbsoluteConstraints
       (20, 30, 350, 230));
    
    jTextField1 = new javax.swing.JTextField ();
    jTextField1.setText ("jTextField1");
    p_propertyModification_tab.add 
      (jTextField1, new com.netbeans.developer.awt.AbsoluteConstraints
       (0, 0, -10, -20));
    
    m_propertyModify_jbutton = new javax.swing.JButton ();
    m_propertyModify_jbutton.setBorder (new javax.swing.border.BevelBorder (0));
    m_propertyModify_jbutton.setText ("Modify List");
    m_propertyModify_jbutton.setFont (new java.awt.Font ("Dialog", 0, 10));
    m_propertyModify_jbutton.addMouseListener (new java.awt.event.MouseAdapter () {
      public void mouseClicked (java.awt.event.MouseEvent evt) {
	m_propertyModify_jbuttonMouseClicked (evt);
      }
    }
					       );
    p_propertyModification_tab.add (m_propertyModify_jbutton, 
				    new com.netbeans.developer.awt.AbsoluteConstraints
				    (60, 350, 130, 20));

     m_property_textField = new javax.swing.JTextField ();
    m_property_textField.setFont (new java.awt.Font ("Dialog", 0, 10));
 m_property_textField.addKeyListener (new java.awt.event.KeyAdapter () {
      public void keyPressed (java.awt.event.KeyEvent evt) {
	m_property_textFieldKeyPressed (evt);
      }
    }
					 );

    p_propertyModification_tab.add (m_property_textField, 
				    new com.netbeans.developer.awt.AbsoluteConstraints 
				    (30, 300, 590, 40));
    
    m_propertyType_comboBox = new javax.swing.JComboBox ();
    m_propertyType_comboBox.setBorder (new javax.swing.border.TitledBorder
				       (new javax.swing.border.EtchedBorder (),
					"Property Type", 1, 2,
					new java.awt.Font ("Dialog", 1, 10)));
    m_propertyType_comboBox.setFont (new java.awt.Font ("Dialog", 0, 10));
      m_propertyType_comboBox.addActionListener (new java.awt.event.ActionListener () {
    
      
      public void actionPerformed (java.awt.event.ActionEvent evt) {
	m_propertyType_comboBoxActionPerformed (evt);
      }
      }
      );
    p_propertyModification_tab.add (m_propertyType_comboBox,
				    new com.netbeans.developer.awt.AbsoluteConstraints
				    (400, 30, 240, 50));

    jPanel1 = new javax.swing.JPanel ();
    jPanel1.setVisible (false);
    jPanel1.setBorder (new javax.swing.border.BevelBorder (0));
    jPanel1.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
    
    p_propertyModification_tab.add (jPanel1,
				    new com.netbeans.developer.awt.AbsoluteConstraints
				    (20, 260, 640, 80));
    
    m_propertyDelete_jbutton = new javax.swing.JButton ();
    m_propertyDelete_jbutton.setBorder (new javax.swing.border.BevelBorder (0));
    m_propertyDelete_jbutton.setText ("Delete from List");
    m_propertyDelete_jbutton.setFont (new java.awt.Font ("Dialog", 0, 10));
    m_propertyDelete_jbutton.addMouseListener (new java.awt.event.MouseAdapter () {
     

      public void mouseClicked (java.awt.event.MouseEvent evt) {
	m_propertyDelete_jbuttonMouseClicked (evt);
      }
    }
					       );
    p_propertyModification_tab.add (m_propertyDelete_jbutton,
				    new com.netbeans.developer.awt.AbsoluteConstraints 
				    (460, 350, 130, 20));
    
    jButton1 = new javax.swing.JButton ();
    jButton1.setBorder (new javax.swing.border.BevelBorder (0));
    jButton1.setText ("Commit to File");
    jButton1.setFont (new java.awt.Font ("Dialog", 0, 10));
    jButton1.addMouseListener (new java.awt.event.MouseAdapter () {
     

      public void mouseClicked (java.awt.event.MouseEvent evt) {
	jButton1MouseClicked (evt);
      }
    }
			       );
    p_propertyModification_tab.add (jButton1,
				    new com.netbeans.developer.awt.AbsoluteConstraints
				    (270, 350, 130, 20));
    
    m_propertyComment_text = new javax.swing.JTextArea ();
    m_propertyComment_text.setEditable(false);
    m_propertyComment_text.setBorder (new javax.swing.border.TitledBorder 
				      (new javax.swing.border.BevelBorder (0),
				       "Comment", 1, 2,
				       new java.awt.Font ("Dialog", 1, 10)));
    m_propertyComment_text.setFont (new java.awt.Font ("Dialog", 0, 10));
    p_propertyModification_tab.add (m_propertyComment_text, 
				    new com.netbeans.developer.awt.AbsoluteConstraints 
				    (400, 100, 240, 160));
    
    jPanel4 = new javax.swing.JPanel ();
    jPanel4.setBorder (new javax.swing.border.BevelBorder (0));
    jPanel4.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());

    p_propertyModification_tab.add (jPanel4, 
				    new com.netbeans.developer.awt.AbsoluteConstraints 
				    (390, 10, 260, 270));
    
    jPanel6 = new javax.swing.JPanel ();
    jPanel6.setBorder (new javax.swing.border.TitledBorder 
		       (new javax.swing.border.BevelBorder (0),
			"Modify Options", 1, 2,
			new java.awt.Font ("Dialog", 1, 10)));
    jPanel6.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
    
    p_propertyModification_tab.add (jPanel6, 
				    new com.netbeans.developer.awt.AbsoluteConstraints
				    (10, 280, 640, 120));
    
    jPanel2 = new javax.swing.JPanel ();
    jPanel2.setBorder (new javax.swing.border.TitledBorder 
		       (new javax.swing.border.BevelBorder (0),
			"Property List", 1, 2,
			new java.awt.Font ("Dialog", 1, 10)));
    jPanel2.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
    
    p_propertyModification_tab.add (jPanel2,
				    new com.netbeans.developer.awt.AbsoluteConstraints
				    (10, 10, 370, 270));
    
    database_tab.addTab ("Property Modification", p_propertyModification_tab);
    
    i_propertyInsert_panel = new javax.swing.JPanel ();
    i_propertyInsert_panel.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
    
    i_insert_jButton = new javax.swing.JButton ();
    i_insert_jButton.setBorder (new javax.swing.border.BevelBorder (0));
    i_insert_jButton.setText ("Insert Property to List");
    i_insert_jButton.setFont (new java.awt.Font ("Dialog", 0, 10));
    i_insert_jButton.addMouseListener (new java.awt.event.MouseAdapter () {
     

      public void mouseClicked (java.awt.event.MouseEvent evt) {
	i_insert_jButtonMouseClicked (evt);
      }
    }
				       );
    i_propertyInsert_panel.add (i_insert_jButton,
				new com.netbeans.developer.awt.AbsoluteConstraints
				(50, 360, 170, 30));
    
    i_clear_jButton = new javax.swing.JButton ();
    i_clear_jButton.setBorder (new javax.swing.border.BevelBorder (0));
    i_clear_jButton.setText ("Clear Form");
    i_clear_jButton.setFont (new java.awt.Font ("Dialog", 0, 10));
    i_clear_jButton.addMouseListener (new java.awt.event.MouseAdapter () {
      public void mouseClicked (java.awt.event.MouseEvent evt) {
	i_clear_jButtonMouseClicked (evt);
      }
    }
				      );
    i_propertyInsert_panel.add (i_clear_jButton, 
				new com.netbeans.developer.awt.AbsoluteConstraints
				(260, 360, 160, 30));
    
    i_commit_jButton = new javax.swing.JButton ();
    i_commit_jButton.setBorder (new javax.swing.border.BevelBorder (0));
    i_commit_jButton.setText ("Commit Property to File");
    i_commit_jButton.setFont (new java.awt.Font ("Dialog", 0, 10));
    i_commit_jButton.addMouseListener (new java.awt.event.MouseAdapter () {
    


      public void mouseClicked (java.awt.event.MouseEvent evt) {
	i_commit_jButtonMouseClicked (evt);
      }
    }
				       );
    i_propertyInsert_panel.add (i_commit_jButton,
				new com.netbeans.developer.awt.AbsoluteConstraints
				(450, 360, 160, 30));
    
    i_propertyType_comboBox = new javax.swing.JComboBox ();
    i_propertyType_comboBox.setBorder (new javax.swing.border.TitledBorder 
				       (new javax.swing.border.BevelBorder (0),
					"Property Type", 1, 2,
					new java.awt.Font ("Dialog", 1, 10)));
    i_propertyType_comboBox.setFont (new java.awt.Font ("Dialog", 0, 10));
     i_propertyType_comboBox.addActionListener (new java.awt.event.ActionListener() {
	 public void actionPerformed (java.awt.event.ActionEvent evt) {
	     i_propertyType_comboBoxActionPerformed (evt);
	 }
     }
						);
    i_propertyInsert_panel.add (i_propertyType_comboBox,
				new com.netbeans.developer.awt.AbsoluteConstraints 
				(20, 20, 200, 50));
    
    i_insertComment_checkBox = new javax.swing.JCheckBox ();
    i_insertComment_checkBox.setText ("Insert Comment");
    i_insertComment_checkBox.setFont (new java.awt.Font ("Dialog", 0, 10));
    i_insertComment_checkBox.addMouseListener (new java.awt.event.MouseAdapter () {
      public void mouseClicked (java.awt.event.MouseEvent evt) {
	i_insertComment_checkBoxMouseClicked(evt);
      }
    }
						);
 i_insertComment_checkBox.addMouseListener (new java.awt.event.MouseAdapter () {
      public void mouseReleased (java.awt.event.MouseEvent evt) {
	i_insertComment_checkBoxMouseReleased(evt);
      }
    }
						);
    i_propertyInsert_panel.add (i_insertComment_checkBox, 
				new com.netbeans.developer.awt.AbsoluteConstraints
				(280, 30, 140, 20));
    
    i_insertProperty_textField = new javax.swing.JTextField ();
    i_insertProperty_textField.setBorder (new javax.swing.border.TitledBorder 
					  (new javax.swing.border.BevelBorder (0),
					   "Insert New Property Below", 1, 2,
					   new java.awt.Font ("Dialog", 1, 10)));
    i_insertProperty_textField.setFont (new java.awt.Font ("Dialog", 0, 10));
    i_propertyInsert_panel.add (i_insertProperty_textField, 
				new com.netbeans.developer.awt.AbsoluteConstraints
				(20, 80, 610, 40));
    
    jScrollPane1 = new javax.swing.JScrollPane ();
    
    i_newProperty_jList = new javax.swing.JList ();
    i_newProperty_jList.setBorder (new javax.swing.border.TitledBorder 
				   (new javax.swing.border.BevelBorder (0),
				    "Properties to be Inserted", 1, 2,
				    new java.awt.Font ("Dialog", 1, 10)));
    jScrollPane1.add (i_newProperty_jList);
    
    jScrollPane1.setViewportView (i_newProperty_jList);
    i_propertyInsert_panel.add (jScrollPane1, 
				new com.netbeans.developer.awt.AbsoluteConstraints
				(350, 150, 280, 180));

    jPanel5 = new javax.swing.JPanel ();
    jPanel5.setBorder (new javax.swing.border.BevelBorder (0));
    jPanel5.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
    
    i_propertyInsert_panel.add (jPanel5,
				new com.netbeans.developer.awt.AbsoluteConstraints
				(20, 350, 610, 50));
    
    jPanel8 = new javax.swing.JPanel ();
    jPanel8.setBorder (new javax.swing.border.BevelBorder (0));
    jPanel8.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
    
    jTextArea1 = new javax.swing.JTextArea ();
    jPanel8.add (jTextArea1, 
		 new com.netbeans.developer.awt.AbsoluteConstraints 
		 (0, 0, -1, -1));

    i_comment_jtextField = new javax.swing.JTextArea ();
    i_comment_jtextField.setBorder (new javax.swing.border.TitledBorder 
				    (new javax.swing.border.BevelBorder (0), 
				     "Insert Comment Below", 1, 2,
				     new java.awt.Font ("Dialog", 1, 10)));
    jPanel8.add (i_comment_jtextField, 
		 new com.netbeans.developer.awt.AbsoluteConstraints 
		 (10, 10, 270, 180));
    
    i_propertyInsert_panel.add (jPanel8, 
				new com.netbeans.developer.awt.AbsoluteConstraints
				(10, 140, 630, 200));

    jPanel7 = new javax.swing.JPanel ();
    jPanel7.setBorder (new javax.swing.border.BevelBorder (0));
    jPanel7.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
    
    i_propertyInsert_panel.add (jPanel7,
				new com.netbeans.developer.awt.AbsoluteConstraints
				(10, 10, 630, 120));
    
    database_tab.addTab ("Insert Property", i_propertyInsert_panel);
    
    getContentPane ().add (database_tab, 
			   new com.netbeans.developer.awt.AbsoluteConstraints
			   (50, 20, 670, 440));
    
  }//GEN-END:initComponents
  
    /*
      THIS IS WHERE THE METHODS ARE CALLED WHEN AN
      ACTION IS PERFORMED
    */


    /**    
	   <h4>Method Usage and Flow:</h4>
	   <ul>
	   <li>This method is performed when
	   <li>the checkbox is clicked. It sets the 
	   <li>boolean value is_pressed to true so
	   <li>we know if the box is still clicked.
	   </ul>
    */
    
  private void i_insertComment_checkBoxMouseClicked
    (java.awt.event.MouseEvent evt) {
    is_pressed = true;
  }
    /**    
	   <h4>Method Usage and Flow:</h4>
	   <ul>
	   <li>This method is performed when
	   <li>the checkbox is unclicked. It sets the 
	   <li>boolean value is_pressed to false so
	   <li>we know if the box is still clicked.
	   </ul>
    */
  private void i_insertComment_checkBoxMouseReleased
      (java.awt.event.MouseEvent evt) {
    is_pressed = false;
  }

     /**    
	   <h4>Method Usage and Flow:</h4>
	   <ul>
	   <li>This method is performed when
	   <li>the button "Initialize Tables" is pressed.
	   <li>It reconnectes to the database, just in case
	   <li>the property file has changed.
	   <li>Initializes the pre-existing tables, or 
	   <li>produces an error statement on standard output.
	   </ul>
    */
  private void d_initializeTables_jButtonMouseClicked 
    (java.awt.event.MouseEvent evt) {
      /*
	Tries to reconnect to the database
      */
      try{
	  host();
	  host_name();
	  sqlStatements();
      }
      catch(SQLException e){
	  System.err.println("d_removetables_buttonMouseClicked: " +e);
      }

      /*
	if we found the file and there is a
	successful connection then go ahead
	and send the initialization queries
	to the database.
      */
      if(found_file && _is_connected){
	  initializeDatabase();
      }
    
      /*
	if not connected to database display
	in the connection window on the Database
	Utility the message below.
      */
      else if(!_is_connected){
	  d_connection_textField.setText("Not Connected");
      }
      
      /*
	if the file add_values.sql was not found then 
	we need to desplay the message in the connection
	window on the database tab.
      */
      else if(!found_file){
	  d_connection_textField.setText("File Not Found");
      }
  }




     /**    
	    <h4>Method Usage and Flow:</h4>
	    <ul>
	    <li>This method is performed when
	    <li>the "Commit to File" button is pushed
	    <li>on the "insert Property" tab.
	    </ul>
     */
  private void i_commit_jButtonMouseClicked 
      (java.awt.event.MouseEvent evt) {
      /*
	takes all elements in the vectors
	and sends them out to the property 
	file.
      */
    commitInsertedProperty(); 

    /*
      we want to clear out the existing vectors
      now that we are done using them.
    */
    _propertyFileElements.removeAllElements();
    _property_elements.removeAllElements();
    /*
      create a new instance of the constants object
      with the revised property file.
    */
    _constants = new Properties(System.getProperties());
    host();
    readPropertyFile();
    element();
    /*
      clear out the remaining vectors
    */
    _new_commented_property.removeAllElements();
    _new_property.removeAllElements();

    }
  
    /**    
	   <h4>Method Usage and Flow:</h4>
	   <ul>
	   <li>This method is performed when
	   <li>the commit button on the Modify
	   <li>property tab is clicked. This will
	   <li>take all the newly modified properties
	   <li>and commit them to the property file.
	   </ul>
    */
  private void jButton1MouseClicked 
	(java.awt.event.MouseEvent evt) {
      commitModifiedProperties();
    
  }

     /**    
	   <h4>Method Usage and Flow:</h4>
	   <ul>
	   <li>This method is performed when
	   <li>the clear button on the database
	   <li>tab is clicked.  It simply clears 
	   <li>the text field, and connection window.
	   </ul>
    */
    private void d_clear_jButtonMouseClicked 
	(java.awt.event.MouseEvent evt) {
	clearNewQuery();
    }
    

     /**    
	   <h4>Method Usage and Flow:</h4>
	   <ul>
	   <li>This method is performed when
	   <li>the commit button on the database
	   <li>tab is clicked. It takes the query
	   <li>that was inserted, tests it , then
	   <li>sends it out to the file. If the query
	   <li>does not work, it will not write out to 
	   <li>the file and an error statement occurs.
	   </ul>
    */
    private void d_commit_jButtonMouseClicked 
	    (java.awt.event.MouseEvent evt) {
	/*
	
	  close current connection and 
	  try to reconnect, property file may
	  have changed.
	*/
    try{
      connection.close();
    }
    catch(SQLException e){
      System.err.println(" d_commit_jButtonMouseClicked: closeConnection:" + e);
    }
      try{
	  host();
	  host_name();
	  sqlStatements();
      }
      catch(SQLException e){
	  System.err.println("d_removetables_buttonMouseClicked: " +e);
      }

      /*
	if the file is not found then 
	we don't want to try to send the 
	queries out to the database.  We 
	will get a Null Pointer Exception.
      */

      if(found_file && _is_connected){
	testQuery();
	
	/*
	  after we tested the query it 
	  can be committed to the file.
	*/
	if(does_query_work){
	    addNewQueryToInitializationFile();
	}
	else{
	    d_connection_textField.setText("The query was not valid");
	}
	does_query_work = false;
      }
      else{
	  d_connection_textField.setText("No File Was Found");
      }
    }
    

    /**    
	   <h4>Method Usage and Flow:</h4>
	   <ul>
	   <li>This method is performed when
	   <li>we want to test a new query.
	   <li>Checks the query by returning a
	   <li>success or failure warning.
	   </ul>
    */
  private void d_testQuery_jButtonMouseClicked   
	      (java.awt.event.MouseEvent evt) {
	/*
	
	  close current connection and 
	  try to reconnect, property file may
	  have changed.
	*/
      try{
	  connection.close();
      }
      catch(SQLException e){
	  System.err.println(" d_testQuery_jButtonMouseClicked : closeConnection:" + e);
      }
      try{
	  host();
	  host_name();
	  sqlStatements();
      }
      catch(SQLException e){
	  System.err.println("d_removetables_buttonMouseClicked: " +e);
      }
      if(_is_connected){
	  testQuery();
      }
      else{
	  d_connection_textField.setText("No connection was made");
      }
  }
     /**    
	   <h4>Method Usage and Flow:</h4>
	   <ul>
	   <li>This method is performed when
	   <li>the clear button on the insert property
	   <li>tab is clicked.  It simply clears 
	   <li>the text fields.
	   </ul>
    */
    private void i_clear_jButtonMouseClicked 
	(java.awt.event.MouseEvent evt) {
	clearForm();
	/*
	  clears all items from the vectors
	*/
	_new_commented_property.removeAllElements();
	_new_property.removeAllElements();
    }
    
     /**    
	   <h4>Method Usage and Flow:</h4>
	   <ul>
	   <li>This method is performed when
	   <li>the insert property to list button is 
	   <li>clicked. It inserts the new property
	   <li>to the list of elements.
	   </ul>
    */
    private void i_insert_jButtonMouseClicked 
	(java.awt.event.MouseEvent evt) {
	
	insertNewProperty();
    }
    


     /*
       I never used this method but could be used
       when an action is performed while in the
       insert property tab.
	  
    */
    private void i_propertyType_comboBoxActionPerformed 
	(java.awt.event.ActionEvent evt) {

    }
    
     /**    
	   <h4>Method Usage and Flow:</h4>
	   <ul>
	   <li>This method is performed when
	   <li>the delete property from list button
	   <li>is clicked. It simply deletes that 
	   <li>element from list and waits for committing.
	   </ul>
    */
    private void m_propertyDelete_jbuttonMouseClicked 
	(java.awt.event.MouseEvent evt) {
	deleteProperty();
    }
    

     /**    
	   <h4>Method Usage and Flow:</h4>
	   <ul>
	   <li>This method is performed when
	   <li>there is a change in the combo box
	   <li>on the modify property tab. Then the
	   <li>tab will refresh with new items.
	   </ul>
    */
    private void m_propertyType_comboBoxActionPerformed
	(java.awt.event.ActionEvent evt) {
	true_property_list.removeAllElements(); 
	displayList();
	comment_text();
    }    

     /**    
	   <h4>Method Usage and Flow:</h4>
	   <ul>
	   <li>This method is performed when
	   <li>we click to modify the list.
	   <li>This is so the user can view all
	   <li>changes before committing to the file.
	   </ul>
    */
    private void m_propertyModify_jbuttonMouseClicked 
	(java.awt.event.MouseEvent evt) {
	modifyProperty();
    }
    
    
    private void m_propertyList_jlistMouseClicked
	(java.awt.event.MouseEvent evt) {
	m_property_textField.setText((String)m_propertyList_jlist.getSelectedValue());
    }
    
    private void d_initializationFile_jListMouseClicked
	(java.awt.event.MouseEvent evt) {
	d_newQuery_textField.setText((String)d_initializationFile_jList.getSelectedValue());
    }
    
    
    private void d_createtables_buttonMouseClicked 
	(java.awt.event.MouseEvent evt) {
	
	
	try{
	    connection.close();
	}
	catch(SQLException e){
	    System.err.println("d_createtables_buttonMouseCliced: closeConnection:" + e);
	}
	try{
	    host();
	    host_name();
	    sqlStatements();
	}
	catch(SQLException e){
	    System.err.println("d_removetables_buttonMouseClicked: " +e);
	}
	if(_is_connected){
	    createDatabase();
	    addCreateTablesToDatabase();
	}
	else{
	    d_connection_textField.setText("No connection was made");
	}
    }
    
    private void d_removetables_buttonMouseClicked 
	(java.awt.event.MouseEvent evt) {
	
	try{
	    connection.close();
	}
    catch(SQLException e){
	System.err.println("d_removetables_buttonMouseClicked: closeConnection:" + e);
    }
    try{
	host();
	host_name();
	sqlStatements();
    }
    catch(SQLException e){
	  System.err.println("d_removetables_buttonMouseClicked: " +e);
      }
      if(_is_connected){ 
	  dropDatabase(_drop_tables);
	  addDropTablesToDatabase();
      }
      else{
	  
	 
	      d_connection_textField.setText("No connection was made");
	  
      }
  }

  private void m_property_textFieldKeyPressed 
			    (java.awt.event.KeyEvent evt) {
  }

  /** Exit the Application */
  private void exitForm
	  (java.awt.event.WindowEvent evt) {
    if(_is_connected){    
    try{
      _buffer.close();
    }
    catch(IOException e){
      System.err.println("InitializeTables: closeBuffer: " +e);
    }


    try{
      connection.close();
    }
    catch(SQLException e){
      System.err.println("InitializeTables: closeConnection:" + e);
    }
    }
    System.exit (0);
  }



  private javax.swing.JTabbedPane database_tab;
  private javax.swing.JPanel database;
  private javax.swing.JPanel p_propertyModification_tab;
  private javax.swing.JPanel i_propertyInsert_panel;
  private javax.swing.JPanel d_hostname_panel;
  private javax.swing.JPanel d_database_panel;
  private javax.swing.JScrollPane jScrollPane2;
  private javax.swing.JScrollPane jScrollPaneNewQ;
  private javax.swing.JPanel jPanel9;
  private javax.swing.JPanel jPanel10;
  private javax.swing.JTextField d_hostname_text;
  private javax.swing.JTextField d_databasename_text;
  private javax.swing.JButton d_removetables_button;
  private javax.swing.JButton d_createtables_button;
  private javax.swing.JTextField d_connection_textField;
  private javax.swing.JList d_initializationFile_jList;
  private javax.swing.JTextArea d_newQuery_textField;
  private javax.swing.JButton d_testQuery_jButton;
  private javax.swing.JButton d_commit_jButton;
  private javax.swing.JScrollPane m_propertyList_scrollpane;
  private javax.swing.JScrollPane m_propertyList_scroller;
  private javax.swing.JTextField jTextField1;
  private javax.swing.JButton m_propertyModify_jbutton;
  private javax.swing.JTextField m_property_textField;
  private javax.swing.JComboBox m_propertyType_comboBox;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JButton m_propertyDelete_jbutton;
  private javax.swing.JButton jButton1;
  private javax.swing.JTextArea m_propertyComment_text;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel6;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JList m_propertyList_jlist;
  private javax.swing.JButton i_insert_jButton;
  private javax.swing.JButton i_clear_jButton;
  private javax.swing.JButton i_commit_jButton;
  private javax.swing.JComboBox i_propertyType_comboBox;
  private javax.swing.JCheckBox i_insertComment_checkBox;
  private javax.swing.JTextField i_insertProperty_textField;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JPanel jPanel8;
  private javax.swing.JPanel jPanel7;
  private javax.swing.JList i_newProperty_jList;
  private javax.swing.JTextArea jTextArea1;
  private javax.swing.JTextArea i_comment_jtextField;
  private javax.swing.JButton d_clear_jButton;
  private javax.swing.JButton d_initializeTables_jButton;
  // End of variables declaration//GEN-END:variables
  private Vector _property_elements = new Vector();
  private Vector _property_key = new Vector();
  private Vector true_property_list = new Vector();
  private Vector _new_property = new Vector();
  private Vector _propertyFileElements = new Vector();
  public BufferedReader _propertyBuffer = null;
  public Vector _deletedProperties = new Vector();
  public Vector _propertyModification = new Vector();
  public boolean _is_connected = false;
  private Vector _add_values = new Vector();
  /**
     BufferedReader stores the data from the file used to initialize the database.
  */
  public BufferedReader _buffer = null;
  /**
     String representing the machine that is accessing the database.
  */
  public String sql_user = new String();
  /**
     String representing the url where the database is located.
  */
  public String sql_url= new String();
  /**
     String that holds the password to the database.
  */
  public String sql_password = new String();
 /**
     String that holds the driver to the database.
  */
  public String sql_driver = new String();
  /**
     creates a connection object called connection
     Used for connecting to the database
  */
  public Connection connection = null;
  /**
     creates a statement stream 
     Used to send sql queries to the database
     using the connection object
  */
  Statement statement = null;
  /**
     Vector that stores the SQL queries
     to create all the necessary tables
     in the database
  */
  Vector test = new Vector();
  /**
     Vector that stores the SQL queries
     to delete all the tables
     in the database
  */
  Vector _drop_tables = new Vector();
  /**
     Vector that holds the property
     that we would like to insert, the 
     property key to see where in the 
     file it needs to be inserted, and 
     the comment for the property
  */
  private Vector _new_commented_property = new Vector();
  /**
     boolean value to determine if the
     comment box is checked on the Insert
     Property tab.
  */
  public boolean is_pressed = false;
  public boolean _modified = false;
  public boolean newList = true;
  public boolean does_query_work = false;
  /**
     creates a property object called
     _constants in order to search through
     the property file
  */
  public Properties _constants = new Properties (System.getProperties());
  /**
     String that stores what directory the 
     user is running the program from.
     This should be the same directory the
     property file and add_values.sql file
     are stored.
  */
  public String user_dir = new String();
  /**
     adds the appropriate file separator
  */
  public String file_separator = new String();
  public String address = new String();
  /**
     This is the database we are currently
     attempting to modify.
  */
  public String database_name = new String();
  public boolean found_file = true;



  public static void main(java.lang.String[] args) {
    new copy_test().show ();
  }
  



  public void modifyProperty(){
    /*
      if there is an item in the text field
      that was modified.
    */
    if(!m_propertyList_jlist.isSelectionEmpty()){
      /*
	get the original property from the list 
      */
      String temp_original = new String((String)m_propertyList_jlist.getSelectedValue());
      /*
	get the modified property from the text field
      */
      String temp_modify = new String((String)m_property_textField.getText());
      /*
	enumerate the list of properties that correspond
	to the key
      */
      Enumeration property = _property_elements.elements();
      
      String temp_property = new String();
      int location = 0;
      /*
	while there are properties in the vector
	that correspond to the key
      */
      while(property.hasMoreElements()){
	/*
	  grab the original property from vector
	*/
	temp_property = new String((String)property.nextElement());
	
	/*
	  if the property from the vector is 
	  equal to the property from the list
	*/
	if(temp_property.equals(temp_original)){
	  /*
	    find the location of where the original sits in
	    the vector
	  */
	  location = _property_elements.indexOf(temp_original);
	  /*
	    remove that element from the vector
	  */
	  _property_elements.removeElementAt(location);
	  /*
	    insert into that position the modified property
	  */
	  _property_elements.insertElementAt(temp_modify,location);
	  /*
	    add to the modification vector both the original
	    for a key and the modified property.
	    This is for committing
	  */
	  _propertyModification.addElement(temp_original);
	  _propertyModification.addElement(temp_modify);
	}
      }
      /*
	clear the list for a refresh
      */
      removeElementsFromList(m_propertyList_jlist);
      true_property_list.removeAllElements();
      /*
	redisplay list with the modified properties
      */
      displayList();		       
    }
    
  }
  



  public void deleteProperty(){
    /*
      get the original property from the list for 
      a key
    */
    String temp_original = new String((String)m_property_textField.getText());
    /*
      enumerate the property vector that corresponds
      to a particular key
    */
    Enumeration property = _property_elements.elements();
    String temp_property = new String();
    int location = 0;

    /*
      while there are still elements in the original
      vector corresponding to the key
    */
    while(property.hasMoreElements()){
      /*
	grab the first original element
      */
      temp_property = new String((String)property.nextElement());
      /*
	compare the original with the key of 
	the element we would like to delete.
      */
      if(temp_property.equals(temp_original)){
	/*
	  find the location of where the one we
	  want to delete sits in the original 
	  vector
	*/
	location = _property_elements.indexOf(temp_original);
	/*
	  add the element we want to delete to the delete
	  vector for when we want to commit changes.
	*/
	_deletedProperties.addElement(_property_elements.elementAt(location));
	/*
	  remove the element from the vector
	  remove the key from the vector
	*/
	_property_elements.removeElementAt(location);
	_property_elements.removeElementAt(location-1);
      }
    }
    /*
      clear the list for refresh
    */
    //  removeElementsFromList(m_propertyList_jlist);
    true_property_list.removeAllElements();
    /*
      display the new list with the deleted
      properties
    */
    displayList();		       
    
  }
  


  public void readPropertyFile(){
    /*
      String that grabs line by line from the file
    */
    String this_line = new String();
    /*
      finds the property file
    */
    FileReader _log = null;
    String _logfile = (user_dir + file_separator +"Hummer.properties");
    
    /*
      try to read the file and store it into a buffer.
    */
    try{
      _log = new FileReader(_logfile);
      _propertyBuffer = new BufferedReader(_log);
    }
    catch(FileNotFoundException e){
      System.err.println("readPropertyFile: openFile: " +e);
    }
    
    /*
      take the buffer line by line and store in the vector
    */
    try{
      while((this_line = _propertyBuffer.readLine())!= null){
	_propertyFileElements.addElement(this_line);
      }
    }
    catch(IOException e){
      System.err.println("Can't open property file:  " +e);
    }
  }
  
  

  public void commitModifiedProperties(){
    /*
      we need to make an enumeration of the following vectors:
      delete
      modify
      original
    */
    Enumeration modifiedProperties;
    Enumeration oldProperties;
    Enumeration deleteProperties;
    /*
      this will stop the while loop once the property has been deleted
    */
    boolean isdeleted = false;
    /*
      this will stop the while loop once the property has been modified
    */
    boolean ismodified = false;
    /*
      enumerates the vector with the properties to be deleted.
    */
    deleteProperties = _deletedProperties.elements();

    /*
      while there are itemes to be deleted
    */
    while(deleteProperties.hasMoreElements()){
      /*
	grabs the current item to be deleted
      */
      String deleteOld = new String((String)deleteProperties.nextElement());
      /*
	enumerates the original properties.
      */
      oldProperties = _propertyFileElements.elements();
      
      /*
	while there are still more elements in the original property
	vector, and while we haven't found the item to be deleted.
      */
      while(oldProperties.hasMoreElements() && !isdeleted){
	/*
	  grabs the current item in the original vector
	*/
	String tempOld = new String((String)oldProperties.nextElement());
	/*
	  compares the old property with the one we want to delete.
	*/
	if(tempOld.indexOf(deleteOld)>=0){
	  /*
	    we want to remove the element in the original vector
	  */
	  _propertyFileElements.removeElementAt
	    (_propertyFileElements.indexOf(tempOld));
	  System.out.println(tempOld +" was deleted from file");
	  /*
	    after we deleted from original vector we can disregard
	    it from the delete vector
	  */
	  _deletedProperties.removeElement(deleteOld);
	  /*
	    break out of while loop 
	  */
	  isdeleted = true;
	}
      }
      /*
	go through while loop again if there are still elements 
	in the delete vector
      */
      isdeleted = false;
    }


    /*
      enumeration of the modification vector
    */
      modifiedProperties = _propertyModification.elements();
     
      /*
	while there are elements to be modified
      */
    while(modifiedProperties.hasMoreElements()){
      /*
	enumerate the original vector
      */
      oldProperties = _propertyFileElements.elements();
      /*
	gets the current property to be modified
      */
      String modifyOld = new String((String)modifiedProperties.nextElement());
     
      /*
	while there are elements in the original vector
	and while there are still elements to be modified
	and while the property to be modified is not found
      */
      while(oldProperties.hasMoreElements() 
	    && modifiedProperties.hasMoreElements() && !ismodified){
	/*
	  gets the current property in the original vector
	*/
	String tempOld  = new String((String)oldProperties.nextElement());
	/*
	  compares the original with the property we want modified.
	  this is not the actual modified property, it is the one we
	  want to have modified.
	*/
	if(tempOld.indexOf(modifyOld)>=0){
	  /*
	    find the location in the original vector of the property
	    that we would like to modify
	  */
	  int location = _propertyFileElements.indexOf(modifyOld);
	  /*
	    once we have found the location we can delete the 
	    original
	  */
	  _propertyFileElements.removeElementAt(location);
	  /*
	    find the location of the modified property.
	  */
	  int location2 = _propertyModification.indexOf(modifyOld);
	  /*
	    grab the actual modified property
	  */
	  modifyOld = new String((String)modifiedProperties.nextElement());
	  /*
	    remove the property we used for a key
	  */
	  _propertyModification.removeElementAt(location2);
	  /*
	    insert the actual modified property into the original 
	    vector
	  */
	  _propertyFileElements.insertElementAt(modifyOld,location);
	  /*
	    go ahead and delete the modified property from the
	    vector
	  */
	  _propertyModification.removeElement(modifyOld);
	  System.out.println(modifyOld +" was added to the file");
	  /*
	    break out of while loop. we have already modified
	  */
	  ismodified = true;
	}
      }
      /*
	check for more elements to be modified
      */
      ismodified = false;
    }
    /*
      clears the list for a refresh
    */
   
    fileOutput(user_dir +file_separator +"Hummer.properties");
    // m_propertyList_jlist.setListData(_propertyFileElements);
  }




 /**
    This method refeshes the list (scrolldown)
     <h4>Method Usage and Flow:</h4>
     <ul>
     <li>Creates an empty vector.
     <li>Returns the index of the list to zero
     <li>Add empty list as the new data
     </ul>
  */  
  
  public void removeElementsFromList(javax.swing.JList tempList){
    /*
      create a new vector with nothing in it
    */
    Vector empty = new Vector();
    /* 
       return index pointer to the beginning 
       of the list
    */
    tempList.indexToLocation(0);
    /*
      clear the list be setting the new
      data to the empty vector
    */
    tempList.setListData(empty);
  }
  
 /**
    This method sends the user inputted query to the database.
     <h4>Method Usage and Flow:</h4>
     <ul>
     <li>Grabs the String from the text field
     <li>Sends it to the database
     <li>If no error the string "successful" is printed
     <li>in the text field above.
     <li>User has the option to commit the query to the 
     <li>Inititalization file.
     </ul>
  */  
  public void testQuery(){
    /*
      String that grabs the query entered by user.
    */
    String temp_testQuery = new String(d_newQuery_textField.getText());
    
    try{
      /*
	Send query to database, check for success
      */
      statement.executeUpdate(temp_testQuery);
      d_connection_textField.setText("Successful");
      does_query_work = true;
    }
    catch(SQLException e){
      does_query_work = false;
      System.err.println("testQuery: " +e);
    }
  }
  


  public void insertNewProperty(){
    /*
      If the commented box is clicked we need
      to add a comment along with the property
    */

    String temp_key = new String((String)i_propertyType_comboBox.getSelectedItem());
    if(i_insertComment_checkBox.isSelected()){
      
      /*
	Storage location for the comment
      */
      String temp_comment = new String((String)i_comment_jtextField.getText());
				       
      /*
	Storage locatioin for the new property
      */
      String temp_property = new String((String)i_insertProperty_textField.getText());
      /*
	vector adds key,comment, then property
      */
      _new_commented_property.addElement(temp_key);
      _new_commented_property.addElement(temp_comment);
      _new_commented_property.addElement(temp_property);
      /*
	adds the comment to the comment test field
      */
      i_newProperty_jList.setListData(_new_commented_property);
      /*
        unchecks the box.
      */
      is_pressed = false;
    }
    /*
      otherwise we want to only store the property
    */
    else{
      /*
	String that stores the new property
      */
      
      String temp_property = new String((String)i_insertProperty_textField.getText());
      /*
	add the key and the property to the vector
      */
      _new_property.addElement(temp_key);
      _new_property.addElement(temp_property);
      /*
	add the property to the new list of added stuff
      */
      i_newProperty_jList.setListData(_new_property);
      /*
	clears the insert property box
      */
      i_insertProperty_textField.setText("");
      i_comment_jtextField.setText("");
    }
  }



  public void commitInsertedProperty(){
    /*
      Enumeration of the properties that need to
      be inserted into the file. The non commented
      properties
    */
    Enumeration insertProperties;
    /*
      Enumeration of the original properties.
    */
    Enumeration oldProperties;
    /*
      Enumeration of the commented properties.
    */
    Enumeration commentProperties;
    /*
      Int value initialization, this
      will find the location in the vector
      of elements where a particular property
      lies.
    */
    int location = -1;
    /*
      tells us whether or not to insert a new
      Property.  The property may already be in
      the file.
    */
    boolean doInsert = true;
    /*
      Stores the old property
    */
    String tempOld = new String();
    /*
      This is the key that corresponds with
      the property we want to insert.
      This is used to find the correct area
      in which the property must be placed in the
      file.
    */
    String insertKey = new String();
    /*
      Storage of the new property we want
      to insert.
    */
    String insertProperty = new String();
    /*
      Storage of the commented property
    */
    String commentProperty = new String();
    /*
      Set up enumerations
    */
    insertProperties = _new_property.elements();
    commentProperties = _new_commented_property.elements();


    /*
      while there are more properties to be inserted
      into the file
    */
    while(insertProperties.hasMoreElements()){
      /*
	Storage of the key, this is how we find out
	which catagory the new property fits into.
      */
      insertKey = new String((String)insertProperties.nextElement());
      /*
	grab the first new property
      */
      insertProperty = new String((String)insertProperties.nextElement());
      /*
	reset the doInsert variable
      */
      doInsert = true;
      /*
	enumerate the old property
	file
      */
      oldProperties = _propertyFileElements.elements();
        
      /*
	while there are still properties left in the old
	property file
      */
      while( oldProperties.hasMoreElements()){
	/*
	  grab the first element in the old property file
	*/
	tempOld = new String((String)oldProperties.nextElement());
	if(tempOld.indexOf(insertKey)>=0){
	  /*
	    we have just found the key 
	    now we check to see if the property matches any
	    of the already existing ones.
	    if it does match then we don't want to 
	    add it to the file.
	  */
	  if(tempOld.indexOf(insertProperty)>=0){
	      doInsert = false;
	  }
	    else{
	      /*
		finds the location of the last property
		that is in the original file.
	      */
	      location = _propertyFileElements.indexOf(tempOld);
	      
	    }
	}
      }
      
      
      /*
	if the property was not in the file then go ahead
	and inserty it.
      */
      if(doInsert){
	/*
	  let user know that the property was inserted correctly
	*/
	  System.out.println(insertProperty +" at " +location);
	  /*
	    insert property at the last location found
	  */
	  _propertyFileElements.insertElementAt(insertProperty,location);
	}

      /*
	we need to remove the property and the key that was 
	just inserted from the vector so we can move on to
	the next one.
      */
	_new_property.removeElement(insertKey);
	_new_property.removeElement(insertProperty);
	/*
	  reset our insert value
	*/
	doInsert = true;
    }


    /*
      while there are properties that need inserting with 
      corresponding comments
    */
    while(commentProperties.hasMoreElements()){
      /*
	storage location for the key
      */
      String temp_key = new String((String)commentProperties.nextElement());
      /*
	storage location of the comment
      */
      String temp_comment = new String((String)commentProperties.nextElement());
      /*
	storage location of the property
      */
      commentProperty = new String((String)commentProperties.nextElement());
      
      /*
	re- enumeration of the original property file
      */
      oldProperties = _propertyFileElements.elements();
      
      /*
	while there are still elements in the property file
      */
      while(oldProperties.hasMoreElements()){
	/*
	  storage location of the old property, that we
	  are currently looking at.
	*/
	tempOld = new String((String)oldProperties.nextElement());
	
	/*
	  if the keys match
	*/
	if(tempOld.indexOf(temp_key)>=0){
	  /*
	    we know we are in the correct category
	    now check to see if the property already
	    exists.
	  */
	  if(tempOld.indexOf(commentProperty)>=0){
	    doInsert = false;
	  }
	  else{
	    /*
	      find location of the last property of the type
	      we are planning on inserting
	    */
	    location = _propertyFileElements.indexOf(tempOld);
	  }
	}
      }
      if(doInsert){
	/*
	  if we do want to insert the property 
	  we also need to insert the comment above it.
	  The format for the comment
	*/
	_propertyFileElements.insertElementAt("#---------------------------" 
				       +"\n" +"#" +temp_comment
				       +"\n" +"#---------------------------",location);
	_propertyFileElements.insertElementAt(commentProperty,location + 1);
      }
      /*
	reset the variable that tells us to insert
      */
      doInsert = true;
      /*
	remove the comment, the key, and the property from
	the vector so we can look at the next item.
      */
      _new_commented_property.removeElement(temp_key);
      _new_commented_property.removeElement(temp_comment);
      _new_commented_property.removeElement(commentProperty); 
    }
    /*
      remove th elements from the list.
    */
    removeElementsFromList(i_newProperty_jList);
    /*
      send the new properties to the file
    */
    fileOutput(user_dir +file_separator +"Hummer.properties");

  }
  
  


  public void clearNewQuery(){
    /*
      Clears the insert query text field
    */
    d_newQuery_textField.setText("");
    /*
      Clears the textField that displays 
      results of actions performed
    */
    d_connection_textField.setText("");
  }
  


  public void initializationFile(){
    /*
      We want to open the initialization file and 
      create a buffer of Strings. This constant
      key searches the property file for the 
      correct path and name of the initialization
      file
    */
    if(_constants.containsKey("jdbc.tools.add_values")){
      String openfile = new String(user_dir +file_separator
				   +_constants.getProperty
				   ("jdbc.tools.add_values"));
      /*
	call open file with the appopriate file name
      */
      openFile(openfile);
    }

    try{
      /*
	load each line into a buffer
      */
      String _this_line = new String();
      while (( _this_line = _buffer.readLine()) != null){
	/*
	  add the elements to the vector.
	*/
	_add_values.addElement(_this_line);
      }
      /*
	sets the scrollable list to the data
	found in the inititialization file.
      */
      d_initializationFile_jList.setListData(_add_values);
    }
    catch(IOException e){
      System.err.println("InitializeTables: addElementsToDatabase: " +e);
    }
  }
  
  public boolean checkInitializationFileForQuery(String query){
    Enumeration add_values = _add_values.elements();
    while(add_values.hasMoreElements()){
      String temp_value = new String((String) add_values.nextElement());
      if(temp_value.indexOf(query)>=0){
	return false;
      }
    }
    return true;
  }
  
  public void clearForm(){
    /*
      Vector that stores nothing
    */
    Vector temp = new Vector();
    /*
      clears the text field where the comment
      was typed
    */
    i_comment_jtextField.setText("");
    /*
      clears the text field where the new
      property was typed.
    */
    i_insertProperty_textField.setText("");
    /*
      replaces the index of the list to 
      point at the beginning of the list
    */
    i_newProperty_jList.indexToLocation(0);
    /*
      place an empty vector in the list
      so it clears the previous items.
    */
    i_newProperty_jList.setListData(temp);
    /*
      now that we have cleared we can
      remove all the elements from the vectors.
    */
    _new_property.removeAllElements();
    _new_commented_property.removeAllElements();
  }


  public void comment_text(){
    /*
      Storage location for the key we want 
      to place the corresponding comment with.
    */
    String temp_key = new String((String)m_propertyType_comboBox.getSelectedItem());
    /*
      checks the key to see if it is a url 
      property. then outputs a comment.
    */
    if(temp_key.indexOf("url")>=0){
      m_propertyComment_text.setText("URL Database Properties"
				     +"\nIf a hostname is not included in the" 
				     +"\nProperties string,"
				     +" \nthen the default will be used."
				     +" \nThe default being the string without" 
				     +"\nthe hostname attached."
				     +" \nFormat for url"
				     +"\njdbc.url.<hostname>=<database url>");
    }
     /*
      checks the key to see if it is a tool 
      property. then outputs a comment.
    */
    else if( temp_key.indexOf("tools")>=0){
      m_propertyComment_text.setText("Tool Properties"
				     +"\nThe tool property finds the location"
				     +" \nof the file or system command it needs"
				     +" \nin order to run"
				     +" \nFormat for tools"
				     +"\njdbc.tool.<type>=<file name & or System call>");
    }
    /*
      checks the key to see if it is a driver 
      property. then outputs a comment.
    */
    else if( temp_key.indexOf("driver")>=0){
      m_propertyComment_text.setText("Driver Properties"
				     +"\nThe driver property finds the location"
				     +" \nof the driver class needed to connect"
				     +" \nto the associated database"
				     +" \nFormat for drivers"
				     +"\njdbc.driver.<hostname>=<database.Driver>");
    }
     /*
      checks the key to see if it is a user 
      property. then outputs a comment.
    */
    else if( temp_key.indexOf("user")>=0){
      m_propertyComment_text.setText("User Properties"
				     +"\nThe user property finds the user login"
				     +" \nneeded to log into a database or a system."
				     +" \nFormat for user"
				     +"\njdbc.user.<hostname>=<username>");
    }
    /*
      checks the key to see if it is a password 
      property. then outputs a comment.
    */
    else if( temp_key.indexOf("password")>=0){
      m_propertyComment_text.setText("Password Properties"
				     +"\nThe password property finds the password"
				     +" \nneeded to log into a database or a system."
				     +" \nFormat for password"
				     +"\njdbc.password.<hostname>=<password>");
    }
     /*
      checks the key to see if it is a level 
      property. then outputs a comment.
    */
    else if( temp_key.indexOf("level")>=0){
      m_propertyComment_text.setText("Default Levels Properties"
				     +"\nThe levels property finds the initial"
				     +" \nvalues for the different type of level"
				     +" \nfor example:  Trust = 5"
				     +" \nFormat for levels"
				     +"\nlevel.DEFAULT_<type>=<value>");
    }
     /*
      checks the key to see if it is a const 
      property. then outputs a comment.
    */
    else if( temp_key.indexOf("const")>=0){
      m_propertyComment_text.setText("Constants Properties"
				     +"\nThe constant property finds the constant"
				     +" \nvalue for a datatype"
				     +" \nFormat for constants"
				     +"\nconst.<datatype>=<value>");
    }
     /*
      checks the key to see if it is a port 
      property. then outputs a comment.
    */
    else if(temp_key.indexOf("port")>=0){
      m_propertyComment_text.setText("Port Properties"
				     +"\nThe port property finds the port"
				     +" \nvalue for a datatype"
				     +" \nFormat for port"
				     +"\nport.<datatype>=<value>");
    }
     /*
      checks the key to see if it is a property
      not defined in a particular category.
    */
    else{
      m_propertyComment_text.setText("Property");
    }
  }


  
  public void displayList(){
    /*
      Enumeration of the original properties found
      in the property file
    */
    Enumeration property = _property_elements.elements();
    /*
      holds the current key 
    */
    String temp_key = new String((String)m_propertyType_comboBox.getSelectedItem());
    
    /*
      while there are still properties in the
      property file
    */
    while(property.hasMoreElements()){
      /*
	stores the property
      */
      String temp_property = new String((String) property.nextElement());
      /*
	if the key is found to match one of the property 
	keys then do nothing.
      */
      if(temp_property.indexOf(temp_key)<0){
      }
      /*
	otherwise we need go to the next element
      */
      else{
	  true_property_list.addElement((String)property.nextElement()); 
      }
      
    }
    /*
      refresh the list by removing all the elements
      and setting the data to the new properties.
    */
   removeElementsFromList(m_propertyList_jlist);
    m_propertyList_jlist.setListData(true_property_list);
   
  }
  



  public void addComboItems(){
    /*
      Enumeration of the keys from the original
      property file
    */
    Enumeration item = _property_key.elements();
    /*
      the boolean value that lets
      us know whether or not we have
      already found the category
      url
    */
    boolean url_value = false;
    /*
      the boolean value that lets
      us know whether or not we have
      already found the category
      constant
    */
    boolean const_value = false;
    /*
      the boolean value that lets
      us know whether or not we have
      already found the category
      levels
    */
    boolean level_value = false;
    /*
      the boolean value that lets
      us know whether or not we have
      already found the category
      drivers
    */
    boolean driver_value = false;
    /*
      the boolean value that lets
      us know whether or not we have
      already found the category
      port
    */
    boolean port_value = false;
    /*
      the boolean value that lets
      us know whether or not we have
      already found the category
      tools
    */
    boolean tool_value = false;
    /*
      the boolean value that lets
      us know whether or not we have
      already found the category
      password
    */
    boolean password_value = false;
    /*
      the boolean value that lets
      us know whether or not we have
      already found the category
      user
    */
    boolean user_value = false;
    
    /*
      while there are still keys in the
      vector
    */
    

    while(item.hasMoreElements()){
      /*
	hold the current key
      */
      String type_of_item = new String((String) item.nextElement());
      /*
	check to see if the key is 
	in the url category
      */
      if(type_of_item.indexOf("jdbc.url")>=0 && url_value == false){
	/*
	  add the key to both the 
	  modify combo box and
	  the insertion combo box
	*/
	i_propertyType_comboBox.addItem("url");
	m_propertyType_comboBox.addItem("url");
        /*
	  value that says we 
	  have already added url
	*/
	url_value = true;
      }
      /*
	otherwise we want to skip the 
	url category
      */
      else if(type_of_item.indexOf("jdbc.url")>=0 && url_value == true){
      }
      /*
	check to see if the key is 
	in the driver category
      */
      else if(type_of_item.indexOf("jdbc.driver")>=0 && driver_value == false){
	/*
	  add the key to both the 
	  modify combo box and
	  the insertion combo box
	*/
	i_propertyType_comboBox.addItem("driver");
        m_propertyType_comboBox.addItem("driver");
         /*
	  value that says we 
	  have already added driver
	*/
	driver_value = true;
      }
       /*
	otherwise we want to skip the 
	driver category
      */
      else if(type_of_item.indexOf("jdbc.driver")>=0 && driver_value == true){
      }
       /*
	check to see if the key is 
	in the port category
      */
      else if(type_of_item.indexOf("port")>=0 && port_value == false){
        	/*
	  add the key to both the 
	  modify combo box and
	  the insertion combo box
	*/
	i_propertyType_comboBox.addItem("port");
        m_propertyType_comboBox.addItem("port");
        /*
	  value that says we 
	  have already added port
	*/
	port_value = true;
      }
      /*
	otherwise we want to skip the 
	port category
      */
      else if(type_of_item.indexOf("port")>=0 && port_value == true){
      }
       /*
	check to see if the key is 
	in the tools category
      */
      else if(type_of_item.indexOf("jdbc.tools")>=0 && tool_value == false){
       	/*
	  add the key to both the 
	  modify combo box and
	  the insertion combo box
	*/
	i_propertyType_comboBox.addItem("tools");
        m_propertyType_comboBox.addItem("tools");
        /*
	  value that says we 
	  have already added tools
	*/
	tool_value = true;
      }
       /*
	otherwise we want to skip the 
	port category
      */
      else if(type_of_item.indexOf("jdbc.tools")>=0 && tool_value == true){
      }
        /*
	check to see if the key is 
	in the password category
      */
      else if(type_of_item.indexOf("jdbc.password")>=0 && password_value == false){
	/*
	  add the key to both the 
	  modify combo box and
	  the insertion combo box
	*/
	i_propertyType_comboBox.addItem("password");
        m_propertyType_comboBox.addItem("password");
	  /*
	  value that says we 
	  have already added password
	*/
	password_value = true;
      }
       /*
	otherwise we want to skip the 
	password category
	 */
      else if(type_of_item.indexOf("jdbc.password")>=0 && password_value == true){
      }
       /*
	check to see if the key is 
	in the user category
      */
      else if(type_of_item.indexOf("jdbc.user")>=0 && user_value == false){
	/*
	  add the key to both the 
	  modify combo box and
	  the insertion combo box
	*/
	i_propertyType_comboBox.addItem("user");
        m_propertyType_comboBox.addItem("user");
         /*
	  value that says we 
	  have already added user
	*/
	user_value = true;
      }
      
       /*
	otherwise we want to skip the 
	user category
	 */
      else if(type_of_item.indexOf("jdbc.user")>=0 && user_value == true){
      }
      /*
	check to see if the key is 
	in the level category
      */
      else if(type_of_item.indexOf("level")>=0 && level_value == false){
		/*
	  add the key to both the 
	  modify combo box and
	  the insertion combo box
	*/
	i_propertyType_comboBox.addItem("level");
        m_propertyType_comboBox.addItem("level");
        /*
	  value that says we 
	  have already added level
	*/
	level_value = true;
      }
       /*
	otherwise we want to skip the 
	levels category
	 */
      else if(type_of_item.indexOf("level")>=0 && level_value == true){
      }
      /*
	check to see if the key is 
	in the constant category
      */
      else if(type_of_item.indexOf("const")>=0 && const_value == false){
        	/*
	  add the key to both the 
	  modify combo box and
	  the insertion combo box
	*/
	i_propertyType_comboBox.addItem("const");
        m_propertyType_comboBox.addItem("const");
       /*
	  value that says we 
	  have already added constant
	*/
	const_value = true;
      }
        /*
	otherwise we want to skip the 
	constant category
	 */
      else if(type_of_item.indexOf("const")>=0 && const_value == true){
      }
      /*
	otherwise if non of the above
	add the key to the combo box
      */
      else{
	
	  m_propertyType_comboBox.addItem(type_of_item);
	  i_propertyType_comboBox.addItem(type_of_item);
      }
    }
  }
  
  

  public void element(){
    /*
      Enumeration of the keys
    */
      Enumeration keys;
      keys = _constants.keys();
      /*
	while there are still keys
	left to search through
      */
      while(keys.hasMoreElements()){
        
	/*
	  The current key we are looking at.
	*/
	String temp_key = new String((String)keys.nextElement());
	/*
	  Store the key
	*/
	_property_key.addElement(temp_key);
	/*
	  store the key in the property vector
	*/
	_property_elements.addElement(temp_key);
        /*
	  store the property along with the key
	*/
	_property_elements.addElement( temp_key +"="
				       + _constants.getProperty(temp_key));
      }
  }
  

    public void addNewQueryToInitializationFile(){
      /*
	Storage for the new query the user 
	typed in
      */
	String query = new String((String)d_newQuery_textField.getText());
	/*
	  add the query to the initialization
	  file vector
	*/
	if(checkInitializationFileForQuery(query)){
	_add_values.addElement(query);
	

	/*
	sets the scrollable list to the data
	found in the inititialization file.
	*/
	removeElementsFromList(d_initializationFile_jList);
	d_initializationFile_jList.setListData(_add_values);
	
	/*
	  create a new file writer that will 
	  write to the initialization file
	*/
	FileWriter _log = null;
	String _logfile = new String(user_dir +file_separator +"add_values.sql");
	BufferedWriter _output = null;
	Writer _print_out = null;
	
	
	try {
	
	  _log = new FileWriter(_logfile);
	  _output = new BufferedWriter (_log);
	 
	  /*
	    enumerate the initialization vector
	  */
	  Enumeration value = _add_values.elements();
	  /*
	    while there are still items in the 
	    vector
	  */
	  while(value.hasMoreElements()){
	    /*
	      current query taken from the file
	    */
	    String _this_line = new String((String)value.nextElement());
	    /*
	      write this back out to the file
	    */
	    _output.write(_this_line +"\n");
	  }
	}
	catch(IOException e){
	    System.err.println("addNewQueryToInitializationFile: " +e);
	} 
	/*
	  close the buffer we used to write to the file
	*/
	try{
	  _output.close();
	}
	catch(IOException e){
	  System.err.println("addNewQueryToInitializationFile: " +e);
	}
	}
	else{
	  d_connection_textField.setText("The query alread exists in file");
	}
    }    
    
    public void host(){
      
	FileInputStream _file = null;
	try {
	  /*
	    find the current user directory. Should
	    be the directory where the property file
	    is stored.
	  */
	  user_dir = _constants.getProperty("user.dir");
	  file_separator = _constants.getProperty("file.separator");
	  _file =  new FileInputStream(user_dir + file_separator +"Hummer.properties");
	    
	  /*
	    create a property constant for the file
	  */
	  _constants.load(new BufferedInputStream(_file));
	  _file.close();
	}
	catch (FileNotFoundException fnfe) {
	    System.err.println("InitializeTables: Hummer.properties file not found.");
	    System.exit(0);
	}
	catch (IOException ioe) {
	    System.err.println("InitializeTables: File Hummer.properties not valid.");
	    System.exit(0);
	}
	catch (NumberFormatException ne) {
	    System.err.println("InitializeTables: Bad port.MESSAGE_PORT property.");
	    System.exit(0);
	}
	
	try {
	  /*
	    get the local host the user is sitting on.
	  */
	  address = InetAddress.getLocalHost().getHostAddress();
	    
	  StringTokenizer nametoken = 
	    new StringTokenizer(InetAddress.getLocalHost().getHostName(), ".");
	  /*
	    grab the database name connected to server.
	  */
	  database_name = new String((String)nametoken.nextToken());
	}
	catch(Exception e){
	  System.err.println("host: " +e);
	}
    }
    



 public void host_name(){
      if (_constants.containsKey("jdbc.url." + address)) {
	sql_url = _constants.getProperty("jdbc.url." + address)
	  + database_name;
      }
      else {
	  sql_url = _constants.getProperty("jdbc.url")
	      + database_name;
      }
      if (_constants.containsKey("jdbc.driver." + address)) {
	  sql_driver = _constants.getProperty("jdbc.driver." + address);
      }
      else {
	  sql_driver = _constants.getProperty("jdbc.driver");
      }
      
      if (_constants.containsKey("jdbc.user." + address)) {
	  sql_user = _constants.getProperty("jdbc.user." + address);
      }
      else {
	  sql_user = _constants.getProperty("jdbc.user");
      }
      if (_constants.containsKey("jdbc.password." + address)) {
	  sql_password = _constants.getProperty("jdbc.password." + address);
      }
      else {
	  sql_password = _constants.getProperty("jdbc.password");
      }
      
      try{
	
	/*
	  look for an appropriate driver to connect
	  to the database
	*/
	Class.forName(sql_driver);
        /*
	  if driver was found we can start connecting
	*/
	_is_connected = true;
      }
      catch(ClassNotFoundException e){
	System.err.println("The driver was not correct");
	System.err.println("hostName: " +e);
      }
      /*
	display both the hummer database name and 
	the current machine the user is sitting on 
	in the text fields on the database tab
      */
      d_databasename_text.setText("hummer_" +database_name);
      d_hostname_text.setText(database_name);
     
 }
    


  public void sqlStatements() throws SQLException {
    /*
      if the appropriate driver was found
      for the system the user is logged into.
    */
    if (_is_connected) {
      /*
	remove all elements that
	are currently in the vectors
      */
      test.removeAllElements();
      _drop_tables.removeAllElements();
      
      try{
	/*
	  try to connect to the database
	  by passing a url, username, and password
	*/
	connection = DriverManager.getConnection
	  (sql_url,sql_user,sql_password);
	/*
	  if the connection was successful 
	  display in the text field on the database
	  tab.
	*/
	d_connection_textField.setText("Connection successful");
	/*
	  create a connection object
	*/
	statement= connection.createStatement();
      }
      catch(SQLException e){
	d_connection_textField.setText("no connection was made");
	_is_connected = false;
	System.err.println("sqlStatements: " +e);
      }
    }
    else{
      d_connection_textField.setText("No connection was made.");
    }
  }


  /**
     This method will drop all existing tables in the database without destroying the database.
     <h4>Method Usage and Flow:</h4>
     <ul>
     <li>Places all the appropriate SQL queries in the vector _drop_tables.
     </ul>
  */
  
  public void dropDatabase(Vector _drop_tables){
    /*
      the connection may have closed
      so we will recreate the connection object.
    */
    if(_is_connected){
    try{
      statement= connection.createStatement();
    }
    catch(Exception e){
      System.err.println("dropDatabase: " +e);
    }
    /*
      holding place for the queries
    */
    String S;
    /*
      the sql statements for removing 
      the existing tables from the 
      database.
    */
    S = "DROP TABLE LOG;";
    _drop_tables.addElement(S);
    S = "DROP TABLE FILTER;";
    _drop_tables.addElement(S);
    S = "DROP TABLE ACCEPT_LIST;";
    _drop_tables.addElement(S);
    S = "DROP TABLE FORWARD_LIST;";
    _drop_tables.addElement(S);
    S = "DROP TABLE FORWARD_PEER;";
    _drop_tables.addElement(S);
    S = "DROP TABLE MANAGER;";
    _drop_tables.addElement(S);
    S = "DROP TABLE LEVELS;";
    _drop_tables.addElement(S);
    S = "DROP TABLE CONFIG_TIME;";
    _drop_tables.addElement(S);
    S = "DROP TABLE SUBORDINATES;";
    _drop_tables.addElement(S);
    S = "DROP TABLE PID;";
    _drop_tables.addElement(S);
    S = "DROP TABLE KILL_FILE;";
    _drop_tables.addElement(S);
    S = "DROP TABLE PGROUPS;";
    _drop_tables.addElement(S);
    S = "DROP TABLE PEERS;";
    _drop_tables.addElement(S);
    S = "DROP TABLE MESSAGE;";
    _drop_tables.addElement(S);
    }
    else{
      d_connection_textField.setText("No connection was made.");
    }
  }

  /**
     This method will create all tables needed in to create the database.
     <h4>Method Usage and Flow:</h4>
     <ul>
     <li>Places all the appropriate SQL queries for creating tables into the vector test.
     </ul>
  */
  public void createDatabase(){
    /*
      holding place for the queries
    */
    String S = new String();
    /*
      connection stream may have been
      close so we will recreate the connection
      object
    */
    if(_is_connected){
    try{
      statement= connection.createStatement();
    }
    catch(Exception e){
      System.err.println("createDatabase: " +e);
    }
    /*
      sql statements that will create all the 
      necessary tables in the database
    */
    try{
      S = "CREATE TABLE LOG (" +
	"trust int,"+
	"coop int," +
	"integ int," +
	"ldate date,"+
	"ltime date," +
	"description varchar(20)," +
	"hostip varchar(20)," +
	"tfile varchar(20)," +
	"tool varchar(10));";
      test.addElement(S);
      
      S = "CREATE TABLE FILTER (" +
	"expression varchar(30),"+
	"dateStart date,"+
	"dateEnd date,"+
	"timeStart date,"+
	"timeEnd date,"+
	"trust int,"+
	"coop int,"+
	"integ int,"+
	"log int,"+
	"alert int,"+
	"inh int);";
      test.addElement(S);
      
      S = "CREATE TABLE ACCEPT_LIST ("+
	"filter varchar(20),"+
	"startAddr varchar(30),"+
	"endAddr varchar(30),"+
	"inh int);";
      test.addElement(S);
      
      S = "CREATE TABLE FORWARD_LIST ("+
	"filter varchar(20),"+
	"host varchar(30),"+
	"inh int);";
      test.addElement(S);
      S = "CREATE TABLE FORWARD_PEER ("+
	"filter varchar(20),"+
	"pgroup varchar(20),"+
	"inh int);";
      test.addElement(S);
      S = "CREATE TABLE MANAGER("+
	"manager varchar(20));";
      test.addElement(S);
      S = "CREATE TABLE LEVELS ("+
	"startAddr varchar(20),"+
	"endAddr varchar(20),"+
	"trust int,"+
	"coop int,"+
	"integ int,"+
	"inh int);";
      test.addElement(S);
      
      S = "CREATE TABLE CONFIG_TIME("+
	"ctime int);";
      test.addElement(S);
      S = "CREATE TABLE SUBORDINATES ("+
	"humName varchar(20),"+
	"subord varchar(20));";
      test.addElement(S);
      S = "CREATE TABLE pid ("+
	"name varchar(20),"+
	"pid int);";
      test.addElement(S);
      S = "CREATE TABLE KILL_FILE("+
	"startAddr varchar(20),"+
	"endAddr varchar(20),"+
	"inh int);";
      test.addElement(S);
      S = "CREATE TABLE PGROUPS("+
	"pgroup text,"+
	"modAddr text,"+
	"email text);";
      test.addElement(S);
      S = "CREATE TABLE PEERS("+
	"pgroup text,"+
	"memAddr text,"+
	"peerSub int,"+
	"peerMod int);";
      test.addElement(S);
      S = "CREATE TABLE MESSAGE ("+
	"pgroup text,"+
	"memAddr text,"+
	"action text,"+
	"rdate date,"+
	"rtime time,"+
	"status int,"+
	"sdate date,"+
	"stime time,"+
	"mpublic int);";
      test.addElement(S);
   }
    catch(Exception e){
      System.err.println("createDatabase: " +e);
    }
    }
    else{
      d_connection_textField.setText("No connection was made");
    }
  }
 



  public void addDropTablesToDatabase(){
    
    /*
      connection stream may have closed
      so we will recreate the connection
      object
    */

      if(_is_connected){
    try{
      statement= connection.createStatement();
    }
    catch(SQLException e){
      System.err.println("addDropTablesToDatabase: " +e);
    }

    /*
      enumerate the vector that holds the sql
      statements to drop the tables in the 
      database
    */
    Enumeration drop = _drop_tables.elements();
    /*
      hold the current query
    */
    String temp = new String();
    /*
      if there is an error mark it.
    */
    boolean error = false;

    /*
      while there are still queries
    */
    while( drop.hasMoreElements()) {
      
      try{
	/*
	  hold current query
	*/
	temp = new String((String)drop.nextElement());
	/*
	  try to send to database
	*/
	statement.executeUpdate(temp);
      }
      catch(SQLException e){
	error = true;
	/*
	  notify user that there was an 
	  error in dropping the table
	*/
	System.err.println(temp +"Table already dropped");
      }
       
    }
    if(error){
      /*
	output on the database tab that there was an
	error..
      */
      d_connection_textField.setText("An error occurred when removing");
    }
    else{
      /*
	output on the database tab that all tables
	were dropped successfully.
      */
      d_connection_textField.setText("Successful");
    }
  }
      else{
	  d_connection_textField.setText("No connection was made");
      }
  }  
  
  public void addCreateTablesToDatabase(){
    /*
      connection stream may have closed 
      so recreate the connection object
    */
    try{
      statement= connection.createStatement();
    }
    catch(SQLException e){
      System.err.println("addCreateTablesToDatabase: " +e);
    }

    /*
      Enumerate the sql statements that
      will create all the tables in the
      database.
    */
    Enumeration enum = test.elements();
    /*
      store current query
    */
    String element = new String();
    /*
      keep track if there were any errors
    */
    boolean error = false;
    
    /*
      while there are still more queries
    */
    while( enum.hasMoreElements()) {
      try{
	//executes our sql statements in the vector
	element = new String((String)enum.nextElement());
	statement.executeUpdate(element);
	
      }
      catch(SQLException e){
	System.err.println("addCreateTablesToDatabase: " +e);
	error = true;
      }
    }

    /*
      if there was an error output error on the
      database tab for the user.
    */
    if(error){
      d_connection_textField.setText("An error occurred when creating.");
    }
    /*
      otherwise output successfull
    */
    else{
      d_connection_textField.setText("Creating Tables was Successful");
    }
  }
  

  public void initializeDatabase(){
    /*
      connection stream may have closed
      so recreate the connection object
    */
    
    try{
      statement= connection.createStatement();
    }
    catch(SQLException e){
      System.err.println("initializeDatabase: " +e);
    }

    /*
      enumerate the elements from the initialization
      file vector
    */
    Enumeration this_line = _add_values.elements();
    
    /*
      while there are still more queries
    */
    while(this_line.hasMoreElements()){
      /*
	store current query
      */
      String temp = new String((String)this_line.nextElement());
      /*
	try to send the statement to the database
      */
      try{
  	statement.executeUpdate(temp);
      }
      catch(SQLException e){
	/*
	  if an error occured write it out
	  on the database tab.
	*/
	d_connection_textField.setText("An error occurred when initializing");
        System.err.println("Error on " +temp);
	System.err.println("initializeDatabase: " +e);
      }
    }
  }
  

  
  public void fileOutput(String args){
    /*
      create a file writer for the property file
    */
    FileWriter _log = null;
    String _logfile = args;
    BufferedWriter _output = null;
    Writer _print_out = null;
    /*
      enumerate the elements in the
      property file vector 
    */
    Enumeration nextItem = _propertyFileElements.elements();
    try {
      /*
	try to write the elements out to the file
      */
      _log = new FileWriter(_logfile);
      _output = new BufferedWriter (_log);
      
      /*
	while there are still more elements to write
	to the file
      */
      while(nextItem.hasMoreElements()){
	_output.write((String)nextItem.nextElement() +"\n");
      }
    }
    catch(IOException e){
      System.err.println("fileOutput: " +e);
    } 

    /*
      close the buffer used to write to the file
    */
    try{
      _output.close();
    }
    catch(IOException e){
      System.err.println("fileOutput" +e);
    }
  }

  /**
     Opens the initializing file that is read in on the command line,
     and places its elements into the database.
     <h4>Method Usage and Flow:</h4>
     <ul>
     <li>Takes the file read from command line and reads it into a buffer.
     </ul>
     @param args The file containing intializing values.
  */
  
  public void openFile(String args){
    /*
      create a file reader in order to 
      read a file
    */
    FileReader _log = null;
    /*
      args is the name of the file
    */
    String _logfile = args;
    
    try{
      _log = new FileReader(_logfile);
      _buffer = new BufferedReader(_log);
    }
    catch(FileNotFoundException e){
      System.err.println("openFile: " +e);
    }
  }
}

