/*
Java Hummer Project
File: HuiLogin.java
Date: 5-6-99
Author: Andy Hoobing and Joel Marlow
Description:  This file has all the code for the Hummer User Interface.  I used
NetBeans (build 112) to make most of this code.  The rest is done by hand.
This is a rather large file.

Copyright (C) 1997-1998 The Hummer Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 *
 * @author Andy Hoobing
 * @version Final
 */


package edu.uidaho.hummer.gui.hui;

import java.io.*;
import java.security.*;
import java.util.*;
import edu.uidaho.hummer.dataobject.Userstruct;
import edu.uidaho.hummer.util.*;
import edu.uidaho.hummer.util.AddUser;


public class HuiLogin extends javax.swing.JFrame {

  /** Initializes the Form */
  public HuiLogin() {
    initComponents ();
    pack ();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    // This code was developed using a non-commercially licensed version of NetBeans Developer 2.x.
    // For details, see http://www.netbeans.com/non_commercial.html

    setTitle ("Hummer User Interface Login");
    addWindowListener (new java.awt.event.WindowAdapter () {
        public void windowClosing (java.awt.event.WindowEvent evt) {
          exitForm (evt);
        }
      }
    );
    getContentPane ().setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());

    jLabel1 = new javax.swing.JLabel ();
    jLabel1.setText ("Username:");
    getContentPane ().add (jLabel1, new com.netbeans.developer.awt.AbsoluteConstraints (10, 30, -1, -1));

    jLabel2 = new javax.swing.JLabel ();
    jLabel2.setText ("Password:");
    getContentPane ().add (jLabel2, new com.netbeans.developer.awt.AbsoluteConstraints (10, 80, -1, -1));

    login_username_text = new javax.swing.JTextField ();
    getContentPane ().add (login_username_text, new com.netbeans.developer.awt.AbsoluteConstraints (100, 30, 160, 20));

    login_password_text = new javax.swing.JPasswordField ();
    getContentPane ().add (login_password_text, new com.netbeans.developer.awt.AbsoluteConstraints (100, 80, 160, 20));

    jScrollPane1 = new javax.swing.JScrollPane ();

      login_status_text = new javax.swing.JTextArea ();
      jScrollPane1.add (login_status_text);

    jScrollPane1.setViewportView (login_status_text);
    getContentPane ().add (jScrollPane1, new com.netbeans.developer.awt.AbsoluteConstraints (40, 190, 270, 110));

    login_loginbutton_button = new javax.swing.JButton ();
    login_loginbutton_button.setBorder (new javax.swing.border.BevelBorder (0));
    login_loginbutton_button.setText ("LOGIN");
    login_loginbutton_button.addMouseListener (new java.awt.event.MouseAdapter () {
        public void mousePressed (java.awt.event.MouseEvent evt) {
          login_loginbutton_buttonMousePressed (evt);
        }
      }
    );
    getContentPane ().add (login_loginbutton_button, new com.netbeans.developer.awt.AbsoluteConstraints (70, 120, 170, 30));

    login_firsttime_check = new javax.swing.JCheckBox ();
    login_firsttime_check.setText ("First Time  Login");
    login_firsttime_check.setFont (new java.awt.Font ("Dialog", 0, 10));
    getContentPane ().add (login_firsttime_check, new com.netbeans.developer.awt.AbsoluteConstraints (100, 160, -1, -1));

  }//GEN-END:initComponents

  private void login_loginbutton_buttonMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_login_loginbutton_buttonMousePressed
    // Add your handling code here:
    try{
    authenticateUser();
    }
    catch(Exception e){
      //This next line was making the whole system freeze whenever there was an exception
      //thrown I think...either that or one of the println statements was doing it.
      //      System.err.println("huilogin: " +e);
    }


  }//GEN-LAST:event_login_loginbutton_buttonMousePressed

  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    System.exit (0);
  }//GEN-LAST:event_exitForm


// Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JTextField login_username_text;
  private javax.swing.JPasswordField login_password_text;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JButton login_loginbutton_button;
  private javax.swing.JCheckBox login_firsttime_check;
  public javax.swing.JTextArea login_status_text;
// End of variables declaration//GEN-END:variables


  /** Variable set if the user checked first time on the login screen */
public boolean _first_time = false;

  /** Variable set to true if user is authenticated. */
public boolean _authenticated = false;

  /** The password the user enters */
public String new_password = null;

  /** Name of the current authenticated user. */
public String current_user = null;

  /** List of users loaded from password file */
public Vector user_array = new Vector();

  /** The structure that holds each piece of user data */
 Userstruct user_data = new Userstruct();

  /** The current number of login tries */
int _current_try = 0;



  /** This function will authenticate a user to HUI.  It will take the password and username
      from the login window and check them against the password file entries.  The user has
      three times to log in.

      @param none
      @returns void
  */
 public void authenticateUser() throws Exception {

    ObjectInputStream instream = null;

    String username = null;
    char[] password = null;
    MessageDigest message_digest = null;
    byte[] real_message_digest = null;
    String real_password = null;


    int size = 0;
    int index = 0;

    //FIX ThIS PASSWORD ThING to BE SECURE



    // get the username, password and first time check
    username = login_username_text.getText();
    password = login_password_text.getPassword();
    if(login_firsttime_check.isSelected())
      _first_time = true;
    else
      _first_time = false;

    //System.out.println("first time: " + _first_time);

    // put the password into a string
    new_password = new String(password);

    // read in from passwords file
   boolean caught_exception = true;
    try {
     instream = new ObjectInputStream(new FileInputStream("passwords"));
     caught_exception = false;
    }
    catch(FileNotFoundException e) {
      //      System.err.println("newpassord: " + new_password);
      AddUser add_file = new AddUser(username, new_password.trim().getBytes());
    }
    catch(IOException e){
      //      System.err.println("No password file. You need to create a password file by doing the following" +
      //                         " command: \njava edu.uidaho.hummer.util.AddUser  <username> <password>");
    }
    if(caught_exception) {
      try {
        instream = new ObjectInputStream(new FileInputStream("passwords"));
  //        System.out.println("why am i here?");
      }
      catch(IOException e){
  //        System.err.println("huilogin:Error while reading password file: " + e);
      }
    }






    try{
      user_array = (Vector)(instream.readObject());
    }
    catch(Exception e){
      //      System.err.println("Problem reading in vector of users: " + e);
    }




    size = user_array.size();






  // search for user in the list
  while(index < size) {
   user_data = (Userstruct)user_array.elementAt(index);

    if(user_data.username.equals(username)) {
     break;
    } // end if

   index++;

  } // end while

  // get the password
  real_message_digest = StaticMethods.getDigest(new_password.getBytes());


  // if the password and username match.
  if(MessageDigest.isEqual(real_message_digest, user_data.password)) {
    _authenticated = true;
    current_user = user_data.username;
    login_status_text.append("AUTHENTICATED: Welcome to HUI\n Please Wait....\n");
  } // end if

  else {
    login_status_text.append("INVALID LOGIN: Try again.\n");
    login_password_text.setText("");
    login_password_text.requestFocus();

    //increment number of tries
    _current_try++;

    // if you have tried three times, you are out
    if(_current_try == 3){
      //      System.out.println("bye " + _current_try);
      System.exit(0);
    }
  } // end else
 }  // end authenticateUser()

  public static void main(java.lang.String[] args) {
    // new huilogin ().show ();
  }

}
