
import java.awt.*;
import java.applet.*;
import java.net.*;
import java.awt.event.*;
import java.sql.*;
import java.io.*;
import java.util.*;

public class MainInterface extends CloseableFrame implements ActionListener{
  private Panel tabs;
  public  String msg = ""; 
 public boolean _is_connected = false;
  /**
BufferedReader stores the data from the file used to initialize the database.
  */
  public BufferedReader _buffer = null;
  /**
String representing the machine that is accessing the database.
  */
  public String sql_user = new String();
  /** 
String representing the url where the database is located.
  */
  public String sql_url= new String();
  /**
String that holds the password to the database.
  */
  public String sql_password = new String(); 
  public Connection connection = null;
  public Statement statement = null;
 
  public Vector _drop_tables = new Vector();
  

  MainInterface(){
    Properties _constants = new Properties(System.getProperties());
    FileInputStream _file = null;
    String sql_driver = new String(); 
    
    try {
      String user_dir = _constants.getProperty("user.dir");
      String file_separator = _constants.getProperty("file.separator");
	_file =  new FileInputStream(user_dir +file_separator +
			   "Hummer.properties");

     
      _constants.load(new BufferedInputStream(_file));
       _file.close();
    }
    catch (FileNotFoundException fnfe) {
      System.err.println("MessagingServer: Hummer.properties file not found.");
      System.exit(0);
    }
    catch (IOException ioe) {
      System.err.println("MessagingServer: File Hummer.properties not valid.");
      System.exit(0);
    }
    catch (NumberFormatException ne) {
      System.err.println("MessagingServer: Bad port.MESSAGE_PORT property.");
      System.exit(0);
    }  
    
    
    try {
      String address = InetAddress.getLocalHost().getHostName();
      StringTokenizer nametoken = new StringTokenizer(address, ".");
      if (_constants.containsKey("jdbc.url." + address)) {
	sql_url = _constants.getProperty("jdbc.url." + address)
	  + nametoken.nextToken();
      }
      else {
	sql_url = _constants.getProperty("jdbc.url") 
	  + nametoken.nextToken();
      }      
      if (_constants.containsKey("jdbc.driver." + address)) {
	sql_driver = _constants.getProperty("jdbc.driver." + address);
      }
      else {
	sql_driver = _constants.getProperty("jdbc.driver");
      }

      if (_constants.containsKey("jdbc.user." + address)) {
	sql_user = _constants.getProperty("jdbc.user." + address);
      }
      else {
	sql_user = _constants.getProperty("jdbc.user");
      }
      if (_constants.containsKey("jdbc.password." + address)) {
	sql_password = _constants.getProperty("jdbc.password." + address);
      }
      else {
	sql_password = _constants.getProperty("jdbc.password");
      }		

      Class.forName(sql_driver);       
      _is_connected = true;
    }
    catch (UnknownHostException uhe) {
      System.err.println("InitializeTables:" + uhe);
    }
    catch (ClassNotFoundException cnfe) {
      System.err.println("InitializeTables:" + cnfe);
      System.exit(0);
    }      
  
    Button yes,no,maybe;
    tabs = new Panel();
    addButton("drop database",tabs);
    addButton("create database",tabs);
    addButton("initialize file",tabs);
    add(tabs,"North");
    
  }

 public void sqlStatements() throws SQLException {
    if (_is_connected) {
   
	_drop_tables.removeAllElements();
	try{
	  	connection = DriverManager.getConnection
	  (sql_url, sql_user, sql_password); 
	System.out.println("Connection successful");
	statement= connection.createStatement();
	}
	catch(SQLException e){
	  System.err.println("InitializeTables: sqlStatements: " +e);
	}
	
    }
  }
  public void dropDatabase(){
    
    /******************************************/
    //sql statements that drop tables
    
    String S;
    
    S = "drop table log;";
    _drop_tables.addElement(S);
    S = "drop table filter;";
    _drop_tables.addElement(S);
    S = "drop table accept_list;";
    _drop_tables.addElement(S);
    S = "drop table forward_list;";
    _drop_tables.addElement(S);
    S = "drop table forward_peer;";
    _drop_tables.addElement(S);
    S = "drop table manager;";
    _drop_tables.addElement(S);
    S = "drop table levels;";
    _drop_tables.addElement(S);
    S = "drop table config_time;";
    _drop_tables.addElement(S);
    S = "drop table subordinates;";
    _drop_tables.addElement(S);
    S = "drop table pid;";
    _drop_tables.addElement(S);
    S = "drop table kill_file;";
    _drop_tables.addElement(S);
    S = "drop table pgroups;";
    _drop_tables.addElement(S);
    S = "drop table peers;";
    _drop_tables.addElement(S);
    S = "drop table message;";
    _drop_tables.addElement(S);
    
  }
  
  public void createTables(Vector test){
	/*****************************************/   
	//sql statements that recreate the tables
       String S = new String();
 
	try{
	S = "CREATE TABLE log (" +
	  "trust int,"+	
	  "coop int," +
	  "integ int," +
	  "ldate date,"+
	  "ltime time," +
	  "description text," +
	  "hostip text," +
	  "file text," +
	  "tool text);";
	test.addElement(S);
	
	S = "CREATE TABLE filter (" +
	  "expression text,"+
	  "date_start date,"+
	  "date_end date,"+
	  "time_start time,"+
	  "time_end time,"+
	  "trust int,"+
	  "coop int,"+
	  "integ int,"+
	  "log int,"+
	  "alert int,"+
	  "inh int);";
	test.addElement(S);
	
	S = "CREATE TABLE accept_list ("+
	  "filter text,"+
	  "start_addr text,"+
	  "end_addr text,"+
	  "inh int);";
	test.addElement(S);

	S = "CREATE TABLE forward_list ("+
	  "filter text,"+
	  "host text,"+
	  "inh int);";
	test.addElement(S);
	
	S = "CREATE TABLE forward_peer ("+
	  "filter text,"+
	  "pgroup text,"+
	  "inh int);";
	test.addElement(S);
	
	S = "CREATE TABLE manager ("+
	  "manager text);";
	test.addElement(S);
	
	S = "CREATE TABLE levels ("+
	  "start_addr text,"+
	  "end_addr text,"+
	  "trust int,"+
	  "coop int,"+
	  "integ int,"+
	  "inh int);";
	test.addElement(S);
	
	S = "CREATE TABLE config_time ("+
	  "ctime int);";
	test.addElement(S);
	
	S = "CREATE TABLE subordinates ("+
	  "hum_name text,"+
	  "subord text);";
	test.addElement(S);
	
	S = "CREATE TABLE pid ("+
	  "name text,"+
	  "pid int);";
	test.addElement(S);
	
	S = "CREATE TABLE kill_file ("+
	  "start_addr text,"+
	  "end_addr text,"+
	  "inh int);";
	test.addElement(S);
	
	S = "CREATE TABLE pgroups ("+
	  "pgroup text,"+
	  "mod_addr text,"+
	  "email text);";
	test.addElement(S);
	
	S = "CREATE TABLE peers ("+
	  "pgroup text,"+
	  "mem_addr text,"+
	  "peer_sub int,"+
	  "peer_mod int);";
	test.addElement(S);
	
	S = "CREATE TABLE message ("+
	  "pgroup text,"+
	  "mem_addr text,"+
	  "action text,"+
	  "rdate date,"+
	  "rtime time,"+
	  "status int,"+
	  "sdate date,"+
	  "stime time,"+
	  "mpublic int);";
	test.addElement(S);
	}
	catch(Exception e){
	  System.err.println("InitializeTables: sqlStatements: " +e);
	}
  }


  public void addElementsToDatabase(Vector test){
    /****************************************************/
    /*adds the elements from the file to the vector test*/
    String _this_line = new String();
    try{
      while (( _this_line = _buffer.readLine()) != null){
	test.addElement(_this_line);
      }
    }
    catch(IOException e){
      System.err.println("InitializeTables: sqlStatements: " +e);
    }
    
    try{
      _buffer.close();
    }
    catch(IOException e){
      System.err.println("InitializeTables: sqlStatements: " +e);
    }
  }

  
  public void createDatabase(Vector test){
    Enumeration enum = test.elements(); 
    String elements = new String();
    while( enum.hasMoreElements()) {
      try{
	//executes our sql statements in the vector
	elements = (String)enum.nextElement();
	statement.executeUpdate(elements);
	System.out.println(elements);
	statement.close();
      }
      catch(SQLException e) {}
    }
    try{
      connection.close();
    }
    catch(SQLException e){
      System.err.println("InitializeTables: sqlStatements:" + e);
    }
  }
  
  
  public void addDeleteToDatabase(){
     	Enumeration drop = _drop_tables.elements();
	  while( drop.hasMoreElements()) {
	   try{ 
            statement.executeUpdate((String)drop.nextElement());
	    statement.close();
	   }
	   catch(SQLException e){}
	  }
	  try{
	    connection.close();
	  }
	  catch(SQLException e){
	    System.err.println("InitializeTables: sqlStatements:" + e);
	  }
  }
  

  /**
Opens the initializing file that is read in on the command line, and places its elements into the database.
  */
  
  public void openFile(String args){
    
    FileReader _log = null;
    String _logfile = args;

    try{
      _log = new FileReader(_logfile);
      _buffer = new BufferedReader(_log);
    }
    catch(FileNotFoundException e){
      System.err.println("InitializeTables: openFile: " +e);
    }
  }


  public void addButton(String name, Panel pname)
    {
      Button b = new Button(name);
      b.addActionListener(this);
      pname.add(b);
    }
  
  
  public void actionPerformed(ActionEvent ae){
     Vector test = new Vector(); 
	test.removeAllElements();
    String str = ae.getActionCommand();
    if(str.equals("drop database")){ 
      try{
      sqlStatements();
      dropDatabase();
      addDeleteToDatabase();
          }
      catch(SQLException e){
      }
    }
    else if(str.equals("create database")){
      try{
	sqlStatements();
	createTables(test);
	createDatabase(test);
      }
      catch(SQLException e){
      }
    }
    else if(str.equals("initialize file")){
 try{
      openFile("add_values.sql");
      sqlStatements();
      addElementsToDatabase(test);
      createDatabase(test);
    }
catch(SQLException e){
      }
    }
    repaint();
  }
  

  public void paint (Graphics g){
    g.drawString(msg,6,100);
  }
    
  public static void main(String args[]) throws SQLException{
    MainInterface appwin = new MainInterface();
    
    appwin.setTitle("Hummer Database");
    appwin.show();
  }
}
