/*  
Java Hummer Project
File: DefaultServerSocket.java
Date: 2-17-99
Author: Chad Ward  
Description:  Tests DefaultServerSocket class.

 Copyright (C) 1997-1998 The Hummer Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
        
package edu.uidaho.hummer.util;

/**
Exception thrown when an attempt is made to perform some operation with a
HummerKeyStore before it has been loaded.  Was created to differentiate with
the normal KeyStoreException, because it is easier to recognize the
common problem of not loading the key store with the many other special
cases where the wrong type of data is give an a parameter.
*/
public class UnloadedKeyStoreException extends Exception {
  public UnloadedKeyStoreException(String message) { super(message); }
  public UnloadedKeyStoreException() { super("UnloadedKeyStoreException"); }
}
